#include "..\ExCommon\TokenID.h"
#include "..\ExCommon\GlobalDef.c"
#include "..\ExCommon\Print16.c"

int main(int argc, char * argv[])
{
    #include "..\ExCommon\MainDef.c"

    DWORD n;

	ZeroMemory(PassTbl, 16 * PASS_NO);

	n = 0;
    while (n < PASS_NO) {
        sprintf(PassTbl + (n * 16), "Pass%d", n);
        n++;
    }

    #include "..\ExCommon\Prolog.c"

	/* Przykad obrazujcy zapis do licznikw za pomoc zaszyfrowanej wiadomoci. */

    // zainicjowanie OutKey
    OutKey = (GetTickCount() & 0xFFFFFF00) | 0xF00;

    // zapis licznikow TeleTokenu z uzyciem szyfrowania
    printf("Zapis licznikow TeleTokenu:");

    n = 0;
    while (n < TokenInfoTbl[TVTTTI_COUNTERS]) {
        ZeroMemory(OutDataA, 16);
        ZeroMemory(OutDataB, 16);
        ZeroMemory(InDataA, 16);
        ZeroMemory(InDataB, 16);

        OutKey++;                                                               // zwikszenie licznika kluczy

        OutDataB[TVTTD_CMD] = TVTTC_CNT_DECRYPT_WRITE;                          // rozkaz zapisu licznikow TeleTokenu z deszyfracja wiadomosci
        OutDataB[TVTTD_PARAM2] = 0;                                             // numer hasla do zdeszyfrowania wiadomosci
		OutDataB[TVTTD_PARAM3] = 100;                                           // numer sektora pamici ulotnej do uycia przy deszyfrowaniu trybem CBC

		/* przygotowanie wiadomosci */
		OutDataA[0] = (BYTE) n;                                                 // numer licznika do zapisania
		OutDataA[1] = TVTTCS_CNT_WRITE;                                         // podrozkaz zapisu wartosci licznika
		OutDataA[2] = 0x34;                                                     // mlodszy bajt wartosci do zapisu do licznika
		OutDataA[3] = 0x12;                                                     // starszy bajt wartosci do zapisu do licznika
		// zaszyfrowanie wiadomosci (uzyte haslo "0")
		rijndaelEncrypt(PassTbl+(0*16), OutDataA);

        TVTT_Calc(OutDataA, OutDataB);                                          // policzenie bloku kontrolnego
        TVTT_CryptBlock(OutDataA, OutKey, SessionKey, TVTT_BLOCK_A, TVTT_PC2T); // zaszyfrowanie pierwszego bloku danych
        TVTT_CryptBlock(OutDataB, OutKey, SessionKey, TVTT_BLOCK_B, TVTT_PC2T); // zaszyfrowanie drugiego bloku danych
        Status = TVTT_Talk(TokenH, 10, OutKey, OutDataA, OutDataB, &InKey, InDataA, InDataB);
        TVTT_CryptBlock(InDataA, InKey, SessionKey, TVTT_BLOCK_A, TVTT_T2PC);   // rozszyfrowanie pierwszego bloku danych
        TVTT_CryptBlock(InDataB, InKey, SessionKey, TVTT_BLOCK_B, TVTT_T2PC);   // rozszyfrowanie drugiego bloku danych

        if (Status) {
            printf("\t%X:%02X\n", Status >> 8, Status & 0xFF);
            break;
		}

        if (TVTT_Check(InDataA,InDataB)) {
            printf("\tBlad bloku kontrolnego!\n");
            break;
        }

        if (InDataB[TVTTD_STATUS]) {
            printf("\t%X\n", InDataB[TVTTD_STATUS]);
            break;
		}

        if (!InKey) {   
            printf("\tWiadomosc nie zaszyfrowana!\n");                          // sprawdzenie czy wiadomosc zaszyfrowana
            break;
        }

        n++;
	}

    if (n == TokenInfoTbl[TVTTTI_COUNTERS]) printf("\tOK\n");

    #include "..\ExCommon\Epilog.c"

    return 0;
}
