#include "..\ExCommon\TokenID.h"
#include "..\ExCommon\GlobalDef.c"
#include "..\ExCommon\Print16.c"

int main(int argc, char * argv[])
{
    #include "..\ExCommon\MainDef.c"

    DWORD   n;
    ZeroMemory(PassTbl,16*PASS_NO);
    n=0;
    while (n<PASS_NO)
        {
        sprintf(PassTbl+(n*16),"Pass%d",n);
        n++;
        };
    #include "..\ExCommon\Prolog.c"

    // zainicjowanie OutKey
    OutKey=(GetTickCount()&0xFFFFFF00)|0xF00;

    // szyfrowanie i deszyfrowanie TeleTokenem
    printf("Szyfrowanie TeleTokenem:");

    n=0;
    while (n<TokenInfoTbl[TVTTTI_PASS_TABLE_SIZE])
        {
        BYTE i,tab[16];
        ZeroMemory(OutDataA,16);
        ZeroMemory(OutDataB,16);
        ZeroMemory(InDataA,16);
        ZeroMemory(InDataB,16);

        OutKey++;                                                           // zwikszenie licznika kluczy

        OutDataB[TVTTD_CMD]=TVTTC_ENCRYPT;                                  // rozkaz szyfrowania TeleTokenem
        OutDataB[TVTTD_PARAM1]=(BYTE)n;                                     // numer klucza do uycia

        TVTT_Rand(tab);

        i=0;                                                                // wypenienie bufora danymi do zapisania
        while (i<16)
            {
            OutDataA[i]=tab[i];
            i++;
            };

        TVTT_Calc(OutDataA,OutDataB);                                       // policzenie bloku kontrolnego
        TVTT_CryptBlock(OutDataA,OutKey,SessionKey,TVTT_BLOCK_A,TVTT_PC2T); // zaszyfrowanie pierwszego bloku danych
        TVTT_CryptBlock(OutDataB,OutKey,SessionKey,TVTT_BLOCK_B,TVTT_PC2T); // zaszyfrowanie drugiego bloku danych
        Status=TVTT_Talk(TokenH,10,OutKey,OutDataA,OutDataB,&InKey,InDataA,InDataB);
        TVTT_CryptBlock(InDataA,InKey,SessionKey,TVTT_BLOCK_A,TVTT_T2PC);   // rozszyfrowanie pierwszego bloku danych
        TVTT_CryptBlock(InDataB,InKey,SessionKey,TVTT_BLOCK_B,TVTT_T2PC);   // rozszyfrowanie drugiego bloku danych

        if (Status)
            {
            printf("\t\t%X:%02X\n",Status>>8,Status&0xFF);
            break;
            };

        if (TVTT_Check(InDataA,InDataB))
            {
            printf("\t\tBlad bloku kontrolnego!\n");
            break;
            };

        if (InDataB[TVTTD_STATUS])
            {
            printf("\t\t%X\n",InDataB[TVTTD_STATUS]);
            break;
            }

        if (!InKey)
            {   
            printf("\t\tWiadomosc nie zaszyfrowana!\n");                    // sprawdzenie czy wiadomoc zaszyfrowana
            break;
            };

        // sprawdzenie poprawnoci szyfrowania

        rijndaelEncrypt(PassTbl+(n*16),tab);
        
        i=0;
        while (i<16)
            {
            if (tab[i]!=InDataA[i]) break;
            i++;
            };

        if (i<16)
            {
            printf("\t\tCrypt - Blad porownania\n");
            break;
            };

        // deszyfrowanie bloku

        ZeroMemory(OutDataA,16);
        ZeroMemory(OutDataB,16);
        ZeroMemory(InDataA,16);
        ZeroMemory(InDataB,16);

        OutKey++;                                                           // zwikszenie licznika kluczy

        OutDataB[TVTTD_CMD]=TVTTC_DECRYPT;                                  // rozkaz deszyfrowania TeleTokenem
        OutDataB[TVTTD_PARAM1]=(BYTE)n;                                     // numer klucza do uycia

        TVTT_Rand(tab);

        i=0;                                                                // wypenienie bufora danymi do zapisania
        while (i<16)
            {
            OutDataA[i]=tab[i];
            i++;
            };

        TVTT_Calc(OutDataA,OutDataB);                                       // policzenie bloku kontrolnego
        TVTT_CryptBlock(OutDataA,OutKey,SessionKey,TVTT_BLOCK_A,TVTT_PC2T); // zaszyfrowanie pierwszego bloku danych
        TVTT_CryptBlock(OutDataB,OutKey,SessionKey,TVTT_BLOCK_B,TVTT_PC2T); // zaszyfrowanie drugiego bloku danych
        Status=TVTT_Talk(TokenH,10,OutKey,OutDataA,OutDataB,&InKey,InDataA,InDataB);
        TVTT_CryptBlock(InDataA,InKey,SessionKey,TVTT_BLOCK_A,TVTT_T2PC);   // rozszyfrowanie pierwszego bloku danych
        TVTT_CryptBlock(InDataB,InKey,SessionKey,TVTT_BLOCK_B,TVTT_T2PC);   // rozszyfrowanie drugiego bloku danych

        if (Status)
            {
            printf("\t\t%X:%02X\n",Status>>8,Status&0xFF);
            break;
            };

        if (TVTT_Check(InDataA,InDataB))
            {
            printf("\t\tBlad bloku kontrolnego!\n");
            break;
            };

        if (InDataB[TVTTD_STATUS])
            {
            printf("\t\t%X\n",InDataB[TVTTD_STATUS]);
            break;
            }

        if (!InKey)
            {   
            printf("\t\tWiadomosc nie zaszyfrowana!\n");                    // sprawdzenie czy wiadomoc zaszyfrowana
            break;
            };

        // sprawdzenie poprawnoci deszyfrowania

        rijndaelDecrypt(PassTbl+(n*16),tab);
        
        i=0;
        while (i<16)
            {
            if (tab[i]!=InDataA[i]) break;
            i++;
            };

        if (i<16)
            {
            printf("\t\tDecrypt - Blad porownania\n");
            break;
            };

        n++;
        };

    if (n==TokenInfoTbl[TVTTTI_PASS_TABLE_SIZE]) printf("\t\tOK\n");

    #include "..\ExCommon\Epilog.c"

    return(0);
};
