#include "..\ExCommon\TokenID.h"
#include "..\ExCommon\GlobalDef.c"
#include "..\ExCommon\Print16.c"

int main(int argc, char * argv[])
{
    #include "..\ExCommon\MainDef.c"

    DWORD   n;
    BYTE    FormatPass[5]=TOKEN_FORMAT_PASS;

    ZeroMemory(PassTbl,16*PASS_NO);

    // sprawdzenie wersji biblioteki
    printf("Odczyt wersji biblioteki\n");
    Status=TVTT_GetVersion(&Ver,&SubVer,&APIVer);
    printf("\tWersja pliku:\t\t%d.%02d\n\tWersja API:\t\t%d\n\n",Ver,SubVer,APIVer);

    // otwarcie dostepu do TeleTokenu
    printf("Otwarcie dostepu do TeleTokenu:");
    TokenInfoTblSize=TVTTTI_TABLE_SIZE;                                     // wpisanie rozmiaru tablicy
    Status=TVTT_FindToken(&TokenH,10,TOKEN_ID,TOKEN_ID_MASK,0,&TokenInfoTblSize,TokenInfoTbl);
    if (Status)
        printf("\t%X:%02X\n",Status>>8,Status&0xFF);
    else
        printf("\tOK\n");

    n=0;
    while (n<TokenInfoTblSize)
        {
        printf((TokenInfoOffsetTbl[n]==TVTTTI_ID)?"\t\t\t\t%s%08X\n":"\t\t\t\t%s%d\n",TokenInfoTextTbl[n],TokenInfoTbl[TokenInfoOffsetTbl[n]]);
        n++;
        };

	// odczytanie nr. seryjnego TeleTokenu
	printf("Odczyt nr. ser. TeleTokenu:");
	Status=TVTT_GetSerialNr(TokenH, 10, SerialNr);
	if (Status)
		printf("\t%X:%02X\n",Status>>8,Status&0xFF);
	else
		printf("\tOK\n");
	printf("Numer seryjny:\t\t\t%02X%02X%02X%02X\n", SerialNr[0], SerialNr[1], SerialNr[2], SerialNr[3]);

	// rozpoczecie sesji
    printf("Rozpoczecie sesji:");
    Status=TVTT_StartSession(TokenH,200);
    if (Status)
        printf("\t\t%X:%02X\n",Status>>8,Status&0xFF);
    else
        printf("\t\tOK\n");

    // format Tokenu
    printf("FormatTokenu:");
    ZeroMemory(OutDataA,16);
    ZeroMemory(OutDataB,16);
    ZeroMemory(InDataA,16);
    ZeroMemory(InDataB,16);
    OutKey=0;                                                               // znacznik wiadomosci nie szyfrowanej
    OutDataB[TVTTD_CMD]=TVTTC_FORMAT;                                       // rozkaz formatowania TeleTokenu
    OutDataB[TVTTD_PARAM1]=(TOKEN_ID&0xff);                                 // najmodszy bajt ID odbiorcy TeleTokenu


	// haso formatowania
    OutDataA[0]=FormatPass[0];
    OutDataA[1]=FormatPass[1];
    OutDataA[2]=FormatPass[2];
    OutDataA[3]=FormatPass[3];
    OutDataA[4]=FormatPass[4];

	// numer seryjny
	OutDataA[5]=5;
	OutDataA[6]=6;
	OutDataA[7]=7;
	OutDataA[8]=8;

    TVTT_Calc(OutDataA,OutDataB);                                           // policzenie bloku kontrolnego
    Status=TVTT_Talk(TokenH,200,OutKey,OutDataA,OutDataB,&InKey,InDataA,InDataB);
    TVTT_CalcSessionKey(SessionKey,PassTbl+(OutDataB[TVTTD_PARAM1]*16),OutDataA,PassTbl+(InDataB[TVTTD_PARAM1]*16),InDataA);   // policzenie klucza sesji
    if (Status==0x0600)
        printf("\t\t\tRestart Tokenu...\n");
    else
        printf("\t\t\t%X:%02X\n",Status>>8,Status&0xFF);

    // zakonczenie sesji
    printf("Zakonczenie sesji:");
    Status=TVTT_EndSession(TokenH);
    if (Status)
        printf("\t\t%X:%02X\n",Status>>8,Status&0xFF);
    else
        printf("\t\tOK\n");

    // zamknicie dostpu do Tokenu
    printf("Zamkniecie dostepu do Tokenu:");
    Status=TVTT_FreeToken(TokenH);
    if (Status)
        printf("\t%X:%02X\n",Status>>8,Status&0xFF);
    else
        printf("\tOK\n");

    Time=GetTickCount()-Time;
    printf("Time: %d.%02d\n",Time/1000,(Time/10)%100);

    return(0);
};
