#include "..\ExCommon\TokenID.h"
#include "..\ExCommon\GlobalDef.c"
#include "..\ExCommon\Print16.c"

int main(int argc, char * argv[])
{
	#include "..\ExCommon\MainDef.c"

	DWORD n, c;                        // liczniki
	unsigned char *data=NULL;          // bufor na dane wejciowe
	unsigned char *pdata;              // pomocniczy wskanik
	unsigned char iv[16];              // init wektor do szyfrowania w trybie CBC

	ZeroMemory(PassTbl, 16 * PASS_NO);
	
	n = 0;
	while (n < PASS_NO) {
		sprintf(PassTbl + (n * 16), "Pass%d", n);
		n++;
	}

	// wylosowanie init vector-a
	TVTT_Rand(iv);

	#include "..\ExCommon\Prolog.c"

	/* Przykad obrazujcy zapis zaszyfrowanych danych do TeleTokenu. Zademonstrowane jest
	   uycie trybu CBC do zaszyfrowania (przygotowania) danych do zapisu do TeleTokenu.
	   Z drugiej strony TeleToken podczas operacji zapisu rozszyfrowywuje dane rwnie
	   w trybie CBC, z uyciem wbudowanej pamici ulotnej (1 sektora). */

	// zainicjowanie OutKey
	OutKey = (GetTickCount() & 0xFFFFFF00) | 0xF00;

	data = malloc(TokenInfoTbl[TVTTTI_NV_MEM_SIZE] * 16);

	// przygotowanie danych do zapisania
	for (n=0; n<TokenInfoTbl[TVTTTI_NV_MEM_SIZE]*16; n++) data[n] = (unsigned char) n;

	/* szyfrowanie metoda CBC */

	// XOR 1 bloku danych z init vector-em
	for (n=0; n<16; n++) data[n] ^= iv[n];

	// petla szyfrujca
	n = TokenInfoTbl[TVTTTI_NV_MEM_SIZE];
	pdata = data;
	while (1) {
		rijndaelEncrypt(PassTbl, pdata);

		if (!--n) break;

		pdata += 16;

		// XOR bloku n z zaszyfrowanym blokiem n-1
		for (c=0; c<16; c++) pdata[c] ^= (pdata - 16)[c];
	}

	/* Przygotowanie sektora pamici ulotnej do deszyfrowania w trybie CBC. Do sektora "0"
	   wgrywany jest "init vector", z ktrym TeleToken automatycznie wykona operacj XOR
	   po uprzednim zdeszyfrowaniu pierwszego bloku danych. Po tej operacji pierwszy
	   zaszyfrowany blok danych trafi do wybranego (tu "0") sektora RAM, na poczet przyszego
	   wykorzystania do operacji XOR. Tym sposobem do wykonania zapisu z deszyfrowaniem
	   w trybie CBC naley tylko raz, przed rozpoczciem deszyfrowania, wgra blok pocztkowy
	   ("init vector") do wybranego sektora pamici RAM. Numer tego sektora podawany jest
	   jako argument w rozkazie "deszyfruj i zapisz". Podanie numeru spoza zakresu (0-7)
	   spowoduje uycie deszyfrowania w trybie ECB (kady blok osobno). */

	// zapis IV do pamici ulotnej

	printf("Zapis pam. ul. TeleTokenu:");

	ZeroMemory(OutDataA, 16);
	ZeroMemory(OutDataB, 16);
	ZeroMemory(InDataA, 16);
	ZeroMemory(InDataB, 16);

	OutKey++;                                                                   // zwikszenie licznika kluczy

	OutDataB[TVTTD_CMD] = TVTTC_VMEM_WRITE;                                     // rozkaz zapisu pamici ulotnej TeleTokenu
	OutDataB[TVTTD_PARAM1] = 0;                                                 // numer sektora do zapisania

	for (n=0; n<16; n++) OutDataA[n] = iv[n];                                   // wypenienie bufora danymi do zapisania

	TVTT_Calc(OutDataA, OutDataB);                                              // policzenie bloku kontrolnego
	TVTT_CryptBlock(OutDataA, OutKey, SessionKey, TVTT_BLOCK_A, TVTT_PC2T);     // zaszyfrowanie pierwszego bloku danych
	TVTT_CryptBlock(OutDataB, OutKey, SessionKey, TVTT_BLOCK_B, TVTT_PC2T);     // zaszyfrowanie drugiego bloku danych
	Status = TVTT_Talk(TokenH, 10, OutKey, OutDataA, OutDataB, &InKey, InDataA, InDataB);
	TVTT_CryptBlock(InDataA, InKey, SessionKey, TVTT_BLOCK_A, TVTT_T2PC);       // rozszyfrowanie pierwszego bloku danych
	TVTT_CryptBlock(InDataB, InKey, SessionKey, TVTT_BLOCK_B, TVTT_T2PC);       // rozszyfrowanie drugiego bloku danych

	if (Status) {
		printf("\t%X:%02X\n", Status >> 8, Status & 0xFF);
		goto fail;
	}

	if (TVTT_Check(InDataA,InDataB)) {
		printf("\tBlad bloku kontrolnego!\n");
		goto fail;
	}

	if (InDataB[TVTTD_STATUS]) {
		printf("\t%X\n", InDataB[TVTTD_STATUS]);
		goto fail;
	}

	if (!InKey) {   
		printf("\tWiadomosc nie zaszyfrowana!\n");                              // sprawdzenie czy wiadomo zaszyfrowana
		goto fail;
	}

	printf("\tOK\n");

	// zapis pamici nieulotnej TeleTokenu

	printf("Zapis pam. nieul. TeleTokenu:");

	n = 0;
	while (n < TokenInfoTbl[TVTTTI_NV_MEM_SIZE]) {
		BYTE i;

		ZeroMemory(OutDataA, 16);
		ZeroMemory(OutDataB, 16);
		ZeroMemory(InDataA, 16);
		ZeroMemory(InDataB, 16);

		OutKey++;                                                               // zwikszenie licznika kluczy

		OutDataB[TVTTD_CMD] = TVTTC_NVMEM_DECRYPT_WRITE;                        // rozkaz zapisu pamici Tokenu z uprzednim rozszyfrowaniem bloku danych
		OutDataB[TVTTD_PARAM1] = (BYTE) n;                                      // numer sektora do zapisania
		OutDataB[TVTTD_PARAM2] = 0;                                             // numer hasa do uycia przy deszyfrowaniu
		OutDataB[TVTTD_PARAM3] = 0;                                             // numer sektora pamici ulotnej do uycia przy deszyfrowaniu trybem CBC

		for (i=0; i<16; i++) OutDataA[i] = data[n * 16 + i];                    // wypenienie bufora danymi do zapisania

		TVTT_Calc(OutDataA, OutDataB);                                          // policzenie bloku kontrolnego
		TVTT_CryptBlock(OutDataA, OutKey, SessionKey, TVTT_BLOCK_A, TVTT_PC2T); // zaszyfrowanie pierwszego bloku danych
		TVTT_CryptBlock(OutDataB, OutKey, SessionKey, TVTT_BLOCK_B, TVTT_PC2T); // zaszyfrowanie drugiego bloku danych
		Status = TVTT_Talk(TokenH, 10, OutKey, OutDataA, OutDataB, &InKey, InDataA, InDataB);
		TVTT_CryptBlock(InDataA, InKey, SessionKey, TVTT_BLOCK_A, TVTT_T2PC);   // rozszyfrowanie pierwszego bloku danych
		TVTT_CryptBlock(InDataB, InKey, SessionKey, TVTT_BLOCK_B, TVTT_T2PC);   // rozszyfrowanie drugiego bloku danych

		if (Status) {
			printf("\t%X:%02X\n", Status >> 8, Status & 0xFF);
			break;
		}

		if (TVTT_Check(InDataA,InDataB)) {
			printf("\tBlad bloku kontrolnego!\n");
			break;
		}

		if (InDataB[TVTTD_STATUS]) {
			printf("\t%X\n", InDataB[TVTTD_STATUS]);
			break;
		}

		if (!InKey) {
			printf("\tWiadomosc nie zaszyfrowana!\n");                          // sprawdzenie czy wiadomo zaszyfrowana
			break;
		}

		n++;
	}

    if (n == TokenInfoTbl[TVTTTI_NV_MEM_SIZE]) printf("\tOK\n");

fail:
    #include "..\ExCommon\Epilog.c"

	if (data) free(data);

	return(0);
}
