//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Root.h"
#include "extern.h"
#include "GlobErr.cpp"
#include "stdio.h"
#include "fcntl.h"
#include <sys\stat.h>
#include "io.h"
extern "C" {
#include "..\TeleTokenApi\rijndael-alg-ref.h"
#include "..\TeleTokenApi\TeleTokenAPI.h"
#include "..\TeleTokenApi\TeleToken.h"
};
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TfrmRoot *frmRoot;
//---------------------------------------------------------------------------
__fastcall TfrmRoot::TfrmRoot(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TfrmRoot::FormCreate(TObject *Sender)
{
  BYTE n;

  TVTTAPI_Initialize();
 	n=0;
	while (n<PASS_NO)
		{
		sprintf(PassTbl+(n*16),"Pass%d",n);
		n++;
		};
}
//---------------------------------------------------------------------------
int __fastcall TfrmRoot::OpenSession()
{
  AnsiString  aErr = "StartSession error\r\n--------------------";

  // sprawdzenie czy uchwyt na TeleToken nie jest wyzerowany
  if (hCon==NULL)
    {
    Memo->Lines->Add(aErr);
    return (-1);
    };

  // prba otwarcia sesji
  NumPassT = TVTTAPI_StartSession(Pass, hCon, 1);

  // obsuga bdw
  Status = GetLastError();
  if (CheckErr(Status)!= 0)
    {
    Memo->Lines->Add(aErr);
    return (-1);
    };

  // obliczenie hase dla rozkazu sesji
  TVTTAPI_CalcPass(Pass, hCon, PassTbl + 16, PassTbl + (NumPassT * 16));

  // obsuga bdw
  Status = GetLastError();
  if (CheckErr(Status)!= 0)
    {
    Memo->Lines->Add(aErr);
    return(-1);
    };

  return(0);
}
//---------------------------------------------------------------------------
int __fastcall TfrmRoot::CloseSession()
{

  // zamknicie sesji
  TVTTAPI_EndSession(Pass, hCon);

  // obsuga bdw
  Status = GetLastError();
  if (CheckErr(Status)!= 0)
    {
    Memo->Lines->Add("EndSession error\r\n--------------------");
    return (-1);
    };

  return (0);
}
//---------------------------------------------------------------------------
void __fastcall TfrmRoot::ApplicationEvents1Message(tagMSG &Msg,
      bool &Handled)
{
  //dodanie zdarzenia losowego do generatora liczb pseudolosowych
  TVTTAPI_Randomize(&Msg);
}
//---------------------------------------------------------------------------
void __fastcall TfrmRoot::btLosujClick(TObject *Sender)
{
  BYTE        tRandom[16];
  AnsiString  sText;
  AnsiString  sLine;

  // generowanie liczb pseudolosowych
  TVTTAPI_Rand(tRandom);
  for (int n=0; n<16; n++)
    {
    sText = IntToHex(tRandom[n], 2);
    sLine = sLine + sText + " ";
    };

  // wywietlenie wygenerowanych liczb
  Memo->Lines->Add(sLine);
}
//---------------------------------------------------------------------------
void __fastcall TfrmRoot::btGetFeatureClick(TObject *Sender)
{
  BYTE        n;
  DWORD       dFeature;
  AnsiString  sTmp;

  Memo->Lines->Add("\r\nGetFeature");

  // ptla odczytujca parametry TeleTokenu
  //---------------------------------------
  for (n=0; n<TVTTTI_TABLE_SIZE; n++)
    {
    // odczyt kolejnego parametru
    dFeature = TVTTAPI_GetFeature(Pass, hCon, n);

    // obsuga bdw
    Status = GetLastError();
    if (CheckErr(Status)!=0)
      {
      Memo->Lines->Add("GetFeature error\r\n--------------------");
      return;
      };
    // zapamitanie parametru TeleTokenu w tablicy
    TTInfo[n] = dFeature;
    // dodanie parametru do linii tekstu
    sTmp = sTmp + InfoText[n] + IntToStr(dFeature) + "\r\n";
    };
  //---------------------------------------
  // wywietlenie odczytanych danych o TeleTokenie
  Memo->Lines->Add(sTmp);
  Memo->Lines->Add(cOK);

}
//---------------------------------------------------------------------------
void __fastcall TfrmRoot::btOpenClick(TObject *Sender)
{
  BYTE  n;

  // sprawdzenie czy otwarto wczeniej TeleToken
  if (hCon!=NULL)
  {
    Memo->Lines->Add("TeleToken jest ju otwarty\r\n--------------------");
    return;
  };

  // losowanie hase dla sesji
  TVTTAPI_Rand(Pass);

  Memo->Lines->Add("Open\r\n");

  // otwarcie pierwszego TeleTokenu o ID zapisanym w TOKEN_ID
  hCon = TVTTAPI_Open(Pass, TOKEN_ID, OwnerMsk, 0);

  // obsuga bdw
  Status = GetLastError();
  if (CheckErr(Status)!= 0)
    {
    Memo->Lines->Add("Open error\r\n--------------------");
    return;
    };
  Memo->Lines->Add(cOK);

  // wywoanie GetFeature w celu odczytania parametrw, TeleTokenu
  btGetFeatureClick(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TfrmRoot::btCloseClick(TObject *Sender)
{
  // zamknicie TeleTokenu
  TVTTAPI_Close(Pass, hCon);
  // obsuga bdw
  Status = GetLastError();
  if (CheckErr(Status)!= 0)
    {
    Memo->Lines->Add("Close error\r\n--------------------");
    return;
    };

  // zwolnienie uchwytu na TeleToken
  hCon = NULL;

  Memo->Lines->Add("Close OK\r\n--------------------");
}
//---------------------------------------------------------------------------
void __fastcall TfrmRoot::btRAMReadClick(TObject *Sender)
{
  BYTE        Buff[16];    // bufor na odczytane dane
  AnsiString  sText;       // linia tekstu
  BYTE        n;           // zmienna pomocnicza

  // otwarcie sesji
  if (OpenSession()!=0) return;

  // odczyt pamici RAM
  TVTTAPI_RamRead(Pass, hCon, 0, Buff);
  // obsuga bdw
  Status = GetLastError();
  if (CheckErr(Status)!= 0)
    {
    Memo->Lines->Add("RamRead error\r\n--------------------");
    CloseSession();                                   // zamknicie sesji
    return;
    };

  // wywietlenie odczytanych danych
  Memo->Lines->Add("\r\nRamRead");
  n = 0;
  sText = "";
  while (n<16)
    {
    sText = sText + " " + IntToHex(Buff[n],2);
    n++;
    };

  Memo->Lines->Add(sText);
  Memo->Lines->Add(cOK);

  // zamknicie sesji
  CloseSession();
};
//---------------------------------------------------------------------------
void __fastcall TfrmRoot::btRAMWriteClick(TObject *Sender)
{
  BYTE        Buff[16];    // bufor na odczytane dane
  AnsiString  sText;       // linia tekstu
  BYTE        n;           // zmienna pomocnicza

  // otwarcie sesji
  if (OpenSession()!=0) return;

  // wypenienie bufora przykadowymi wartociami
  TVTTAPI_Rand(Buff);

  // zapis bufora do pamici RAM
  TVTTAPI_RamWrite(Pass, hCon, 0, Buff);

  // obsuga bdw
  Status = GetLastError();
  if (CheckErr(Status)!= 0)
    {
    Memo->Lines->Add("RamWrite error\r\n--------------------");
    CloseSession();
    return;
    };

  // wywietlenie danych zapisanych do pamici
  Memo->Lines->Add("\r\nRamWrite");
  n = 0;
  sText = "";
  while (n<16)
    {
    sText = sText + " " + IntToHex(Buff[n],2);
    n++;
    };

  Memo->Lines->Add(sText);
  Memo->Lines->Add(cOK);

  // zamknicie sesji
  CloseSession();
}
//---------------------------------------------------------------------------
void __fastcall TfrmRoot::btMemWriteClick(TObject *Sender)
{
  BYTE        Buff[16];    // bufor na odczytane dane
  AnsiString  sText;       // linia tekstu
  BYTE        n,k;         // zmienne pomocnicze

  // otwarcie sesji
  if (OpenSession()!=0) return;

  // ptla zapisu do pamici TeleTokenu
  //---------------------------------------
  n = 0;
  Memo->Lines->Add("\r\nMemWrite");
  while (n<TTInfo[TVTTTI_NV_MEM_SIZE])
    {
    // wypenienie bufora przykadowymi wartociami
    TVTTAPI_Rand(Buff);

    // zapis bufora do pamici
    TVTTAPI_MemWrite(Pass, hCon, n, Buff);

    // obsuga bdw
    Status = GetLastError();
    if (CheckErr(Status)!= 0)
      {
      Memo->Lines->Add("MemWrite error\r\n--------------------");
      CloseSession();
      return;
      };

    // wywietlenie danych zapisanych do pamici
    k = 0;
    sText = "";
    while (k<16)
      {
      sText = sText + " " + IntToHex(Buff[k],2);
      k++;
      };
    Memo->Lines->Add(sText);

    // zwikszenie licznika sektorw
    n++;
    };
  //---------------------------------------

  Memo->Lines->Add(cOK);

  // zamknicie sesji
  CloseSession();
}
//---------------------------------------------------------------------------
void __fastcall TfrmRoot::btMemReadClick(TObject *Sender)
{
  BYTE        Buff[16];    // bufor na odczytane dane
  AnsiString  sText;       // linia tekstu
  BYTE        n,k;         // zmienne pomocnicze

  // otwarcie sesji
  if (OpenSession()!=0) return;

  // ptla odczytu z pamici TeleTokenu
  //---------------------------------------
  n = 0;
  Memo->Lines->Add("\r\nMemRead");
  while (n<TTInfo[TVTTTI_NV_MEM_SIZE])
    {
    // odczyt z pamici
    TVTTAPI_MemRead(Pass, hCon, n, Buff);

    // obsuga bdw
    Status = GetLastError();
    if (CheckErr(Status)!= 0)
      {
      Memo->Lines->Add("MemRead error\r\n--------------------");
      CloseSession();
      return;
      };

    // wywietlenie danych odczytanych z pamici
    k = 0;
    sText = "";
    while (k<16)
      {
      sText = sText + " " + IntToHex(Buff[k],2);
      k++;
      };
    Memo->Lines->Add(sText);

    // zwikszenie licznika sektorw
    n++;
    };
  //---------------------------------------

  Memo->Lines->Add(cOK);

  // zamknicie sesji
  CloseSession();
}
//---------------------------------------------------------------------------
void __fastcall TfrmRoot::btMemWProtectClick(TObject *Sender)
{
  BYTE        NumPassT;    // numer hasa TeleTokenu
  BYTE        Buff[16];    // bufor na odczytane dane
  AnsiString  sText;       // linia tekstu
  BYTE        n,k;         // zmienna pomocnicza

  // otwarcie sesji
  if (OpenSession()!=0) return;

  // ptla zapisu do pamici TeleTokenu
  //---------------------------------------
  n = 0;
  Memo->Lines->Add("\r\nMemWriteProtect");
  while (n<TTInfo[TVTTTI_PROTECT_MEM_SIZE])
    {
    // wypenienie bufora przykadowymi wartociami
    TVTTAPI_Rand(Buff);

    // zapis bufora do pamici
    TVTTAPI_MemWriteProtect(Pass, hCon, n, Buff);

    // obsuga bdw
    Status = GetLastError();
    if (CheckErr(Status)!= 0)
      {
      Memo->Lines->Add("MemWriteProtect error\r\n--------------------");
      CloseSession();                               // zamknicie sesji
      return;
      };

    // wywietlenie danych zapisanych do pamici
    k = 0;
    sText = "";
    while (k<16)
      {
      sText = sText + " " + IntToHex(Buff[k],2);
      k++;
      };
    Memo->Lines->Add(sText);

    // zwikszenie licznika sektorw
    n++;
    };
  //---------------------------------------

  Memo->Lines->Add(cOK);

  // zamknicie sesji
  CloseSession();
}
//---------------------------------------------------------------------------
void __fastcall TfrmRoot::btMemProtectClick(TObject *Sender)
{
  BYTE  n;

  // otwarcie sesji
  if (OpenSession()!=0) return;

  // ptla zabezpieczajca zapis do sektorw TeleTokenu
  //---------------------------------------
  Memo->Lines->Add("\r\nMemProtect");
  while (n<TTInfo[TVTTTI_PROTECT_MEM_SIZE])
    {
    // zabezpieczenie zapisu do pamici sektora n
    TVTTAPI_MemProtect(Pass, hCon, n);

    // obsuga bdw
    Status = GetLastError();
    if (CheckErr(Status)!= 0)
      {
      Memo->Lines->Add("MemProtect error\r\n--------------------");
      CloseSession();                                   // zamknicie sesji
      return;
      };

    // zwikszenie licznika sektorw
    n++;
  };
  //---------------------------------------

  Memo->Lines->Add(cOK);

  // zamknicie sesji
  CloseSession();
}
//---------------------------------------------------------------------------
void __fastcall TfrmRoot::btCounterWriteClick(TObject *Sender)
{
  BYTE  n;
  AnsiString sText;

  // otwarcie sesji
  if (OpenSession()!=0) return;

  // ptla zapisu wartoci licznikw
  //---------------------------------------
  n = 0;
  sText = "";
  Memo->Lines->Add("\r\nCounterWrite");
  while (n<TTInfo[TVTTTI_COUNTERS])
    {
    // zapis wartoci licznika
    TVTTAPI_CounterWrite(Pass, hCon, n, (0x55 + n));

    // obsuga bdw
    Status = GetLastError();
    if (CheckErr(Status)!= 0)
      {
      Memo->Lines->Add("CounterWrite error\r\n--------------------");
      CloseSession();                                   // zamknicie sesji
      return;
      };
    sText = sText + " " + IntToHex(int(0x55 + n),2);

    // zwikszenie wartoci licznika ptli
    n++;
    };
  //---------------------------------------

  Memo->Lines->Add(sText);
  Memo->Lines->Add(cOK);

  // zamknicie sesji
  CloseSession();
}
//---------------------------------------------------------------------------
void __fastcall TfrmRoot::btCounterReadClick(TObject *Sender)
{
  BYTE  n;
  DWORD cnt;
  AnsiString sText;

  // otwarcie sesji
  if (OpenSession()!=0) return;

  // ptla odczytu wartoci licznikw
  //---------------------------------------
  n = 0;
  sText = "";
  Memo->Lines->Add("\r\nCounterRead");
  while (n<TTInfo[TVTTTI_COUNTERS])
    {
    // odczyt wartoci licznikw
    cnt = TVTTAPI_CounterRead(Pass, hCon, n);

    // obsuga bdw
    Status = GetLastError();
    if (CheckErr(Status)!= 0)
      {
      Memo->Lines->Add("CounterRead error\r\n--------------------");
      CloseSession();                                   // zamknicie sesji
      return;
      };
    sText = sText + " " + IntToHex(int(cnt),2);

    // zwikszenie wartoci licznika ptli
    n++;
    };
  //---------------------------------------

  Memo->Lines->Add(sText);
  Memo->Lines->Add(cOK);

  // zamknicie sesji
  CloseSession();
}
//---------------------------------------------------------------------------
void __fastcall TfrmRoot::btCounterIncReadClick(TObject *Sender)
{
  BYTE  n;
  DWORD cnt;
  AnsiString sText;

  // otwarcie sesji
  if (OpenSession()!=0) return;

  // ptla zwikszajca i odczytujca wartoci
  // licznikw
  //---------------------------------------
  n = 0;
  sText = "";
  Memo->Lines->Add("\r\nCounterIncRead");
  while (n<TTInfo[TVTTTI_COUNTERS])
    {
    // zwikszenie i odczyt wartoci licznika
    cnt = TVTTAPI_CounterIncRead(Pass, hCon, n);

    // obsuga bdw
    Status = GetLastError();
    if (CheckErr(Status)!= 0)
      {
      Memo->Lines->Add("CounterIncRead error\r\n--------------------");
      CloseSession();                                   // zamknicie sesji
      return;
      };
    sText = sText + " " + IntToHex(int(cnt),2);

    // zwikszenie wartoci licznika ptli
    n++;
    };
  //---------------------------------------

  Memo->Lines->Add(sText);
  Memo->Lines->Add(cOK);

  // zamknicie sesji
  CloseSession();
}
//---------------------------------------------------------------------------
void __fastcall TfrmRoot::btCounterDecReadClick(TObject *Sender)
{
  BYTE  n;
  DWORD cnt;
  AnsiString sText;

  // otwarcie sesji
  if (OpenSession()!=0) return;

  // ptla zmniejszajca i odczytujca wartoci
  // licznikw
  //---------------------------------------
  n = 0;
  sText = "";
  Memo->Lines->Add("\r\nCounterDecRead");
  while (n<TTInfo[TVTTTI_COUNTERS])
    {
    // zmniejszenie i odczyt wartoci licznika
    cnt = TVTTAPI_CounterDecRead(Pass, hCon, n);

    // obsuga bdw
    Status = GetLastError();
    if (CheckErr(Status)!= 0)
      {
      Memo->Lines->Add("CounterDecRead error\r\n--------------------");
      CloseSession();                                   // zamknicie sesji
      return;
      };
    sText = sText + " " + IntToHex(int(cnt),2);

    // zwikszenie wartoci licznika ptli
    n++;
    };
  //---------------------------------------

  Memo->Lines->Add(sText);
  Memo->Lines->Add(cOK);

  // zamknicie sesji
  CloseSession();
}
//---------------------------------------------------------------------------
void __fastcall TfrmRoot::btCounterIncEncryptReadClick(TObject *Sender)
{
  BYTE  m, n, k;
  BYTE  Buff[16];
  BYTE  tTmp[16];
  AnsiString  sText;

  // otwarcie sesji
  if (OpenSession()!=0) return;

  // ptla zwikszajca i odczytujca wartoci
  // licznikw w postaci zaszyfrowanej
  //---------------------------------------
  n = 0;
  sText = "";
  Memo->Lines->Add("\r\nCounterIncCryptRead");
  while (n<TTInfo[TVTTTI_COUNTERS])
    {
    // zwikszenie i odczyt zaszyfrowanej wartoci licznika
    TVTTAPI_CounterIncEncryptRead(Pass, hCon, n, n, Buff );

    // obsuga bdw
    Status = GetLastError();
    if (CheckErr(Status)!= 0)
      {
      Memo->Lines->Add("CounterIncCryptRead error\r\n--------------------");
      CloseSession();                                   // zamknicie sesji
      return;
      };
    // rozszyfrowanie i wywietlenie stanu licznika
    m = 0;
    while (m<16)
      {
      tTmp[m] = Buff[m];
      m = m + 1;
      };
    rijndaelDecrypt(PassTbl + (n * 16), tTmp);               //odszyfrowanie odczytanego stanu licznika
    sText = IntToHex(tTmp[1], 2);
    sText = sText + IntToHex(tTmp[0], 2) + "| ";


    // wywietlenie zaszyfrowanych wartoci zwrconych przez funkcje
    k = 0;
    while (k<16)
      {
      sText = sText + " " + IntToHex(Buff[k],2);
      k++;
      };
    Memo->Lines->Add(sText);

    // zwikszenie wartoci licznika ptli
    n++;
    };
  //---------------------------------------

  Memo->Lines->Add(cOK);

  // zamknicie sesji
  CloseSession();
}
//---------------------------------------------------------------------------
void __fastcall TfrmRoot::btCounterConfigWriteClick(TObject *Sender)
{
  BYTE  n, Config0, Config1;

  // otwarcie sesji
  if (OpenSession()!=0) return;

  // ptla zapisujca konfiguracje licznikw
  //---------------------------------------
  n = 0;
  Memo->Lines->Add("\r\nCounterConfigWrite");
  while (n<TTInfo[TVTTTI_COUNTERS])
    {
    // konfiguracja licznikw
    Config0 = TVTTCC0_WRITE|TVTTCC0_READ|TVTTCC0_INC_READ|TVTTCC0_DEC_READ|
              TVTTCC0_INC_ENCRYPT_READ|TVTTCC0_STOP_AT_ZERO|TVTTCC0_NVMEM_READ|
              TVTTCC0_NVMEM_WRITE;
    Config1 = TVTTCC1_PASS|TVTTCC1_CONFIG_ENABLED;

    // zapis konfiguracji
    TVTTAPI_CounterConfigWrite(Pass, hCon, n, Config0, Config1);    // zabezpieczenie zapisu do pamici

    // obsuga bdw
    Status = GetLastError();
    if (CheckErr(Status)!= 0)
      {
      Memo->Lines->Add("CounterConfigWrite error\r\n--------------------");
      CloseSession();                                   // zamknicie sesji
      return;
      };

    // zwikszenie wartoci licznika ptli
    n++;
    };
  //---------------------------------------

  Memo->Lines->Add(cOK);

  // zamknicie sesji
  CloseSession();
}
//---------------------------------------------------------------------------
void __fastcall TfrmRoot::btCounterConfigSetClick(TObject *Sender)
{
  BYTE  n, Config0, Config1;

  // otwarcie sesji
  if (OpenSession()!=0) return;

  // ptla ustawiajca bity konfiguracji licznikw
  // (wszystkie wczone)
  //---------------------------------------
  n = 0;
  Memo->Lines->Add("\r\nCounterConfigSet");
  while (n<TTInfo[TVTTTI_COUNTERS])
    {
    // ustawienie bitw konfiguracyjnych
    Config0 = TVTTCC0_WRITE|TVTTCC0_READ|TVTTCC0_INC_READ|TVTTCC0_DEC_READ|
              TVTTCC0_INC_ENCRYPT_READ|TVTTCC0_STOP_AT_ZERO|TVTTCC0_NVMEM_READ|
              TVTTCC0_NVMEM_WRITE;
    Config1 = TVTTCC1_PASS|TVTTCC1_CONFIG_ENABLED;

    // przesanie do TeleTokenu bitw konfiguracji do ustawienia
    TVTTAPI_CounterConfigSet(Pass, hCon, n, Config0, Config1);

    // obsuga bdw
    Status = GetLastError();
    if (CheckErr(Status)!= 0)
      {
      Memo->Lines->Add("CounterConfigSet error\r\n--------------------");
      CloseSession();                                   // zamknicie sesji
      return;
      };

    // zwikszenie wartoci licznika ptli
    n++;
    };
  //---------------------------------------

  Memo->Lines->Add(cOK);

  // zamknicie sesji
  CloseSession();
}
//---------------------------------------------------------------------------
void __fastcall TfrmRoot::btCounterConfigClearClick(TObject *Sender)
{
  BYTE  n, Config0, Config1;

  // otwarcie sesji
  if (OpenSession()!=0) return;

  // ptla zerujca bity konfiguracji licznikw
  // (wszystkie wyczone)
  //---------------------------------------
  n = 0;
  Memo->Lines->Add("\r\nCounterConfigClear");
  while (n<TTInfo[TVTTTI_COUNTERS])
    {
    // bity konfiguracji do wyzerowania
    Config0 = TVTTCC0_WRITE|TVTTCC0_READ|TVTTCC0_INC_READ|TVTTCC0_DEC_READ|
              TVTTCC0_INC_ENCRYPT_READ|TVTTCC0_STOP_AT_ZERO|TVTTCC0_NVMEM_READ|
              TVTTCC0_NVMEM_WRITE;
    Config1 = TVTTCC1_PASS|TVTTCC1_CONFIG_ENABLED;

    // przesanie do TeleTokenu bitw konfiguracji do wyzerowania
    TVTTAPI_CounterConfigClear(Pass, hCon, n, Config0, Config1);

    // obsuga bdw
    Status = GetLastError();
    if (CheckErr(Status)!= 0)
      {
      Memo->Lines->Add("CounterConfigClear error\r\n--------------------");
      CloseSession();                                   // zamknicie sesji
      return;
      };

    // zwikszenie wartoci licznika ptli
    n++;
    };
  Memo->Lines->Add(cOK);

  // zamknicie sesji
  CloseSession();
}
//---------------------------------------------------------------------------
void __fastcall TfrmRoot::btPassWriteClick(TObject *Sender)
{
  BYTE  n;

  // otwarcie sesji
  if (OpenSession()!=0) return;

  // ptla zapisujca hasa do TeleTokenu
  //---------------------------------------
  n = 0;
  Memo->Lines->Add("\r\nPassWrite");
  while (n<TTInfo[TVTTTI_PASS_TABLE_SIZE])
    {
    // zapis hase do TeleTokenu
    TVTTAPI_PassWrite(Pass, hCon, n, PassTbl + (n * 16));

    // obsuga bdw
    Status = GetLastError();
    if (CheckErr(Status)!= 0)
      {
      Memo->Lines->Add("PassWrite error\r\n--------------------");
      CloseSession();                                   // zamknicie sesji
      return;
      };

    // zwikszenie licznika ptli
    n++;
    };
  //---------------------------------------

  Memo->Lines->Add(cOK);

  // zamknicie sesji
  CloseSession();
}
//---------------------------------------------------------------------------
void __fastcall TfrmRoot::btPassConfigWriteClick(TObject *Sender)
{
  BYTE  n, Config0, Config1;

  // otwarcie sesji
  if (OpenSession()!=0) return;

  // ptla zapisujca konfiguracje hase do TeleTokenu
  //---------------------------------------
  n = 0;
  Memo->Lines->Add("\r\nPassConfigWrite");
  while (n<TTInfo[TVTTTI_PASS_TABLE_SIZE])
    {
    // konfiguracja bitw hase
    Config0 = TVTTPC0_TOKEN|TVTTPC0_PASS_WRITE|TVTTPC0_PASS_CONFIG|
              TVTTPC0_MEM_READ|TVTTPC0_MEM_WRITE|TVTTPC0_ENCRYPT|
              TVTTPC0_DECRYPT;
    Config1 = TVTTPC1_CNT_READ|TVTTPC1_CNT_WRITE|TVTTPC1_CNT_CONFIG|
              TVTTPC1_ENCRYPT_PASS|TVTTPC1_DECRYPT_PASS|TVTTPC1_CNT_ENCRYPT_PASS|
              TVTTPC1_WRITE_ENABLED|TVTTPC1_CONFIG_ENABLED;

    // przesanie do TeleTokenu bitw konfiguracji hase
    TVTTAPI_PassConfigWrite(Pass, hCon, n, Config0, Config1);

    // obsuga bdw
    Status = GetLastError();
    if (CheckErr(Status)!= 0)
      {
      Memo->Lines->Add("PassConfigWrite error\r\n--------------------");
      CloseSession();                                   // zamknicie sesji
      return;
      };

    // zwikszenie licznika ptli
    n++;
    };
  //---------------------------------------

  Memo->Lines->Add(cOK);

  // zamknicie sesji
  CloseSession();
}
//---------------------------------------------------------------------------
void __fastcall TfrmRoot::btPassConfigSetClick(TObject *Sender)
{
  BYTE  n, Config0, Config1;

  // otwarcie sesji
  if (OpenSession()!=0) return;

  // ptla ustawiajca bity konfiguracji hase TeleTokenu
  //---------------------------------------
  n = 0;
  Memo->Lines->Add("\r\nPassConfigSet");
  while (n<TTInfo[TVTTTI_PASS_TABLE_SIZE])
    {
    // konfiguracja bitw hase
    Config0 = TVTTPC0_TOKEN|TVTTPC0_PASS_WRITE|TVTTPC0_PASS_CONFIG|
              TVTTPC0_MEM_READ|TVTTPC0_MEM_WRITE|TVTTPC0_ENCRYPT|
              TVTTPC0_DECRYPT;
    Config1 = TVTTPC1_CNT_READ|TVTTPC1_CNT_WRITE|TVTTPC1_CNT_CONFIG|
              TVTTPC1_ENCRYPT_PASS|TVTTPC1_DECRYPT_PASS|TVTTPC1_CNT_ENCRYPT_PASS|
              TVTTPC1_WRITE_ENABLED|TVTTPC1_CONFIG_ENABLED;

    // przesanie do TeleTokenu bitw konfiguracji hase do ustawienia
    TVTTAPI_PassConfigSet(Pass, hCon, n, Config0, Config1);

    // obsuga bdw
    Status = GetLastError();
    if (CheckErr(Status)!= 0)
      {
      Memo->Lines->Add("PassConfigSet error\r\n--------------------");
      CloseSession();                                   // zamknicie sesji
      return;
      };

    // zwikszenie licznika ptli
    n++;
    };
  //---------------------------------------

  Memo->Lines->Add(cOK);

  // zamknicie sesji
  CloseSession();
}
//---------------------------------------------------------------------------

void __fastcall TfrmRoot::PassConfigClearClick(TObject *Sender)
{
  BYTE  n, Config0, Config1;

  // otwarcie sesji
  if (OpenSession()!=0) return;

  // ptla zerujca bity konfiguracji hase TeleTokenu
  //---------------------------------------
  n = 0;
  Memo->Lines->Add("\r\nPassConfigClear");
  while (n<TTInfo[TVTTTI_PASS_TABLE_SIZE])
    {
    // konfiguracja bitw hase
    Config0 = TVTTPC0_TOKEN|TVTTPC0_PASS_WRITE|TVTTPC0_PASS_CONFIG|
              TVTTPC0_MEM_READ|TVTTPC0_MEM_WRITE|TVTTPC0_ENCRYPT|
              TVTTPC0_DECRYPT;
    Config1 = TVTTPC1_CNT_READ|TVTTPC1_CNT_WRITE|TVTTPC1_CNT_CONFIG|
              TVTTPC1_ENCRYPT_PASS|TVTTPC1_DECRYPT_PASS|TVTTPC1_CNT_ENCRYPT_PASS|
              TVTTPC1_WRITE_ENABLED|TVTTPC1_CONFIG_ENABLED;

    // przesanie do TeleTokenu bitw konfiguracji hase do wyzerowania
    TVTTAPI_PassConfigClear(Pass, hCon, n, Config0, Config1);

    // obsuga bdw
    Status = GetLastError();
    if (CheckErr(Status)!= 0)
      {
      Memo->Lines->Add("PassConfigClear error\r\n--------------------");
      CloseSession();                                   // zamknicie sesji
      return;
      };

    // zwikszenie licznika ptli
    n++;
    };
  //---------------------------------------

  Memo->Lines->Add(cOK);

  // zamknicie sesji
  CloseSession();
}
//---------------------------------------------------------------------------
void __fastcall TfrmRoot::btEncryptClick(TObject *Sender)
{
  BYTE  k;
  AnsiString sText;

  // otwarcie sesji
  if (OpenSession()!=0) return;

  //wywietlenie informacji o danych wejciowych
  sText = "";
  Memo->Lines->Add("\r\nEncrypt");
  sprintf(CryptBuff, "Test Crypt.....\0");
  sText.printf("\r\nInput ASCII:\r\n\r\n%s\r\n", CryptBuff);
  Memo->Lines->Add(sText);
  Memo->Lines->Add("Input HEX:\r\n");
  k = 0;
  sText="";
  while (k<16)
    {
    sText = sText + " " + IntToHex(CryptBuff[k], 2);
    k++;
    };
  Memo->Lines->Add(sText);

  // szyfrowanie bloku TeleTokenem przy uyciu pierwszego hasa
  TVTTAPI_Encrypt(Pass, hCon, 1, CryptBuff);

  // obsuga bdw
  Status = GetLastError();
  if (CheckErr(Status)!= 0)
    {
    Memo->Lines->Add("Encrypt error\r\n--------------------");
    CloseSession();                                   // zamknicie sesji
    return;
    };

  // wywietlenie zaszyfrowanego bloku
  Memo->Lines->Add("\r\nOutput HEX:\r\n");
  k = 0;
  sText = "";
  while (k<16)
    {
    sText = sText + " " + IntToHex(CryptBuff[k], 2);
    k++;
    };
  Memo->Lines->Add(sText);
  Memo->Lines->Add(cOK);

  // zamknicie sesji
  CloseSession();
}
//---------------------------------------------------------------------------
void __fastcall TfrmRoot::btDecryptClick(TObject *Sender)
{
  BYTE  k;
  AnsiString sText;

  // otwarcie sesji
  if (OpenSession()!=0) return;

  //wywietlenie informacji o danych wejciowych
  k = 0;
  sText = "";
  Memo->Lines->Add("\r\nDecrypt\r\n");
  Memo->Lines->Add("Input HEX:\r\n");
  while (k<16)
    {
    sText = sText + " " + IntToHex(CryptBuff[k],2);
    k++;
    };
  Memo->Lines->Add(sText);

  // deszyfrowanie bloku przy uyciu pierwszego hasa
  TVTTAPI_Decrypt(Pass, hCon, 1, CryptBuff);

  // obsuga bdw
  Status = GetLastError();
  if (CheckErr(Status)!= 0)
    {
    Memo->Lines->Add("Decrypt error\r\n--------------------");
    CloseSession();                                   // zamknicie sesji
    return;
    };

  // wywietlenie danych wyjciowych
  sText.printf("\r\nOutput ASCII:\r\n\r\n%s\r\n", CryptBuff);
  Memo->Lines->Add(sText);

  Memo->Lines->Add("\r\nOutput HEX:\r\n");
  k = 0;
  sText = "";
  while (k<16)
    {
    sText = sText + " " + IntToHex(CryptBuff[k], 2);
    k++;
    };

  Memo->Lines->Add(sText);
  Memo->Lines->Add(cOK);

  // zakoczenie sesji
  CloseSession();
}
//---------------------------------------------------------------------------
void __fastcall TfrmRoot::btEncryptBlockClick(TObject *Sender)
{
  AnsiString  aErr = "EncryptBlock error\r\n--------------------";
  int         in, out;      // uchwyty na pliki wejcia/wyjcia
  AnsiString  FName;        // nazwa pliku do odczytu
  int         FSize;        // rozmiar pliku do zaszyfrowania
  int         FReaded;      // rozmiar danych odczytanych z pliku
  char        *Buff;        // bufor na dane wejciowe
  BYTE        *Crypt;       // bufor na dane wyjciowe
  DWORD       OutSize;      // rozmiar w bajtach bloku zaszyfrowanego


  Memo->Lines->Add("\r\nEncryptBlock");

  // otwarcie okna dialogu
  if (!OpenDlg->Execute())
    {
    Memo->Lines->Add(aErr);
    return;
    };

  // otwarcie pliku rda
  in = open(OpenDlg->FileName.c_str(), O_RDONLY | O_BINARY);
  if ( in == -1)
   {
      Memo->Lines->Add(aErr);
      return;
   };

  // otwarcie pliku docelowego (zakodowanego)
  FName = OpenDlg->FileName + ".crp";
  out = open(FName.c_str(), O_WRONLY | O_CREAT | O_TRUNC | O_BINARY);
  if (out == -1)
   {
      Memo->Lines->Add(aErr);
      close(in);
      return;
   };

  // otwarcie sesji
  if (OpenSession()!=0)
    {
    close(in);
    close(out);
    return;
    };

  // alokowanie bufora pamici na dane
  FSize = filelength(in);
  Buff =(char*) malloc(FSize);
  if (!Buff)
    {
    Memo->Lines->Add(aErr);
    close(in);
    close(out);
    return;
    };

  // odczyt pliku do zaszyfrowania
  FReaded = read(in, Buff, FSize);

  if (FReaded == FSize)
    {
    // szyfrowanie bloku danych TeleTokenem
    Crypt = TVTTAPI_EncryptBlock(Pass, hCon, 1, Buff, FSize, &OutSize);

    // zwolnienie pamici danych do zaszyfrowania
    free(Buff);

    // obsuga bdw
    Status = GetLastError();
    if (CheckErr(Status)!= 0) Memo->Lines->Add(aErr);
    }
  else Memo->Lines->Add(aErr);

  // zapis zaszyfrowanych danych do pliku
  write(out, Crypt, OutSize);

  // zamknicie plikw
  close(in);
  close(out);

  // zwolnienie pamici danych zaszyfrowanych
  TVTTAPI_FreeBlock(Crypt, OutSize);
  if (CheckErr(Status)!= 0)
    {
    Memo->Lines->Add(aErr);
    CloseSession();                                   // zamknicie sesji
    return;
    };

  Memo->Lines->Add(cOK);

  // zakoczenie sesji
  CloseSession();
}
//---------------------------------------------------------------------------
void __fastcall TfrmRoot::btDecryptBlockClick(TObject *Sender)
{
  AnsiString  aErr = "DecryptBlock error\r\n--------------------";
  int         in, out;      // uchwyty na pliki wejcia/wyjcia
  AnsiString  FName;        // nazwa zaszyfrowanego pliku do odczytu
  int         FReaded;      // rozmiar zaszyfrowanych danych odczytanych z pliku
  char        *Buff;        // bufor na zaszyfrowane dane wejciowe
  BYTE        *Decrypt;     // bufor na dane wyjciowe
  DWORD       OutSize;      // rozmiar w bajtach bloku zdeszyfrowanego
  int         FSize;        // rozmiar pliku do zdeszyfrowania

  Memo->Lines->Add("\r\nDecryptBlock");

  // otwarcie okna dialogu
  OpenDlg->Filter = "Crypt files (*.crp)|*.CRP";
  if (!OpenDlg->Execute())
    {
    Memo->Lines->Add(aErr);
    return;
    };

  // otwarcie pliku rda
  in = open(OpenDlg->FileName.c_str(), O_RDONLY|O_BINARY);
  if ( in == -1)
   {
      Memo->Lines->Add(aErr);
      return;
   };

  // otwarcie pliku docelowego (zakodowanego)
  FName = OpenDlg->FileName;
  FName +=".dcrp";
  out = open(FName.c_str(), O_WRONLY|O_CREAT|O_TRUNC|O_BINARY);
  if (out == -1)
   {
      Memo->Lines->Add(aErr);
      close(in);
      return;
   };

  // otwarcie sesji
  if (OpenSession()!=0)
    {
    close(in);
    close(out);
    return;
    };

  // alokowanie bufora pamici na dane
  FSize = filelength(in);
  Buff =(char*) malloc(FSize);
  if (!Buff)
    {
    Memo->Lines->Add(aErr);
    close(in);
    close(out);
    return;
    };

  // odczyt pliku do odszyfrowania
  FReaded = read(in, Buff, FSize);
  if (FReaded == FSize)
    {
    Decrypt = TVTTAPI_DecryptBlock(Pass, hCon, 1, Buff, &OutSize);
    free(Buff);

    // obsuga bdw
    Status = GetLastError();
    if (CheckErr(Status)!= 0) Memo->Lines->Add(aErr);
    }
  else Memo->Lines->Add(aErr);

  // zapis zaszyfrowanych danych do pliku
  write(out, Decrypt, OutSize);

  // zamknicie plikw
  close(in);
  close(out);

  // zwolnienie pamici danych rozszyfrowanych
  TVTTAPI_FreeBlock(Decrypt, OutSize);
  if (CheckErr(Status)!= 0)
    {
    Memo->Lines->Add(aErr);
    CloseSession();                                   // zamknicie sesji
    return;
    };

  Memo->Lines->Add(cOK);

  // zakoczenie sesji
  CloseSession();
}
//---------------------------------------------------------------------------


