#include <windows.h>
#define __TVTTS_FNC__
#include "TeleToken.h"
#include "rijndael-alg-ref.h "


BYTE    RandKeyA[16];                                                       // generator liczb pseudolosowych - pierwsza poowa klucza generatora
BYTE    RandKeyB[16];                                                       // generator liczb pseudolosowych - pierwsza poowa klucza generatora
BYTE    RandCnt[16];                                                        // generator liczb pseudolosowych - licznik wywoa generatora liczb pseudolosowych
BYTE    RandRand[16*32];                                                    // generator liczb pseudolosowych - bufor na kolejk zdarze losowych
BYTE    RandRandNr[256];                                                    // generator liczb pseudolosowych - licznik kolejkowania zdarze losowych
DWORD   RandRandCnt[32];                                                    // generator liczb pseudolosowych - licznik zdarze w kolejkach

HANDLE hTeleTokenDll=INVALID_HANDLE_VALUE;
DWORD TVTT_Int_Init(void);

//---------------------------------------------------------------------------

DWORD CALLBACK TVTT_GetVersion_NULL(DWORD * Ver, DWORD * SubVer, DWORD *APIVer);
DWORD CALLBACK TVTT_FindToken_NULL(DWORD *TokenH, DWORD TimeOut, DWORD OwnerID, BYTE OwnerMsk, BYTE Skip, DWORD * FeatureTblSize, DWORD * FeatureTbl);
DWORD CALLBACK TVTT_FreeToken_NULL(DWORD TokenH);
DWORD CALLBACK TVTT_StartSession_NULL(DWORD TokenH, DWORD TimeOut);
DWORD CALLBACK TVTT_Talk_NULL(DWORD TokenH, DWORD TimeOut, DWORD OutKey, BYTE *OutDataA, BYTE *OutDataB, DWORD *InKey, BYTE *InDataA, BYTE *InDataB);
DWORD CALLBACK TVTT_EndSession_NULL(DWORD TokenH);

//---------------------------------------------------------------------------

DWORD (CALLBACK* TVTT_GetVersion)(DWORD * Ver, DWORD * SubVer, DWORD *APIVer)=TVTT_GetVersion_NULL;
DWORD (CALLBACK* TVTT_FindToken)(DWORD *TokenH, DWORD TimeOut, DWORD OwnerID, BYTE OwnerMsk, BYTE Skip, DWORD * FeatureTblSize, DWORD * FeatureTbl)=TVTT_FindToken_NULL;
DWORD (CALLBACK* TVTT_FreeToken)(DWORD TokenH)=TVTT_FreeToken_NULL;
DWORD (CALLBACK* TVTT_StartSession)(DWORD TokenH, DWORD TimeOut)=TVTT_StartSession_NULL;
DWORD (CALLBACK* TVTT_Talk)(DWORD TokenH, DWORD TimeOut, DWORD OutKey, BYTE *OutDataA, BYTE *OutDataB, DWORD *InKey, BYTE *InDataA, BYTE *InDataB)=TVTT_Talk_NULL;
DWORD (CALLBACK* TVTT_EndSession)(DWORD TokenH)=TVTT_EndSession_NULL;

//---------------------------------------------------------------------------

DWORD CALLBACK TVTT_GetVersion_NULL(DWORD * Ver, DWORD * SubVer, DWORD *APIVer)
{
DWORD Res;
Res=TVTT_Int_Init();
if (Res) return(Res);
return(TVTT_GetVersion(Ver,SubVer,APIVer));
};

DWORD CALLBACK TVTT_FindToken_NULL(DWORD *TokenH, DWORD TimeOut, DWORD OwnerID, BYTE OwnerMsk, BYTE Skip, DWORD * FeatureTblSize, DWORD * FeatureTbl)
{
DWORD Res;
Res=TVTT_Int_Init();
if (Res) return(Res);
return(TVTT_FindToken(TokenH,TimeOut,OwnerID,OwnerMsk,Skip,FeatureTblSize,FeatureTbl));
};

DWORD CALLBACK TVTT_FreeToken_NULL(DWORD TokenH)
{
DWORD Res;
Res=TVTT_Int_Init();
if (Res) return(Res);
return(TVTT_FreeToken(TokenH));
};

DWORD CALLBACK TVTT_StartSession_NULL(DWORD TokenH, DWORD TimeOut)
{
DWORD Res;
Res=TVTT_Int_Init();
if (Res) return(Res);
return(TVTT_StartSession(TokenH,TimeOut));
};

DWORD CALLBACK TVTT_Talk_NULL(DWORD TokenH, DWORD TimeOut, DWORD OutKey, BYTE *OutDataA, BYTE *OutDataB, DWORD *InKey, BYTE *InDataA, BYTE *InDataB)
{
DWORD Res;
Res=TVTT_Int_Init();
if (Res) return(Res);
return(TVTT_Talk_NULL(TokenH,TimeOut,OutKey,OutDataA,OutDataB,InKey,InDataA,InDataB));
};

DWORD CALLBACK TVTT_EndSession_NULL(DWORD TokenH)
{
DWORD Res;
Res=TVTT_Int_Init();
if (Res) return(Res);
return(TVTT_EndSession(TokenH));
};

//---------------------------------------------------------------------------

DWORD TVTT_Int_Init(void)
{
void * Ptr;

if (hTeleTokenDll==INVALID_HANDLE_VALUE)
    {
    hTeleTokenDll=LoadLibrary("TeleToken.dll");
    if (hTeleTokenDll==INVALID_HANDLE_VALUE) return(TVTTS_DLL_INIT_FAILED);
    }

Ptr=GetProcAddress(hTeleTokenDll,"TVTT_GetVersion");
if (Ptr)
    TVTT_GetVersion=Ptr;
else
    return(TVTTS_DLL_INIT_FAILED);

Ptr=GetProcAddress(hTeleTokenDll,"TVTT_FindToken");
if (Ptr)
    TVTT_FindToken=Ptr;
else
    return(TVTTS_DLL_INIT_FAILED);

Ptr=GetProcAddress(hTeleTokenDll,"TVTT_FreeToken");
if (Ptr)
    TVTT_FreeToken=Ptr;
else
    return(TVTTS_DLL_INIT_FAILED);

Ptr=GetProcAddress(hTeleTokenDll,"TVTT_StartSession");
if (Ptr)
    TVTT_StartSession=Ptr;
else
    return(TVTTS_DLL_INIT_FAILED);

Ptr=GetProcAddress(hTeleTokenDll,"TVTT_Talk");
if (Ptr)
    TVTT_Talk=Ptr;
else
    return(TVTTS_DLL_INIT_FAILED);

Ptr=GetProcAddress(hTeleTokenDll,"TVTT_EndSession");
if (Ptr)
    TVTT_EndSession=Ptr;
else
    return(TVTTS_DLL_INIT_FAILED);

return(TVTTS_OK);
};

/*****************************************************************************
Funkcja liczy blok kontrolny wiadomoci i umieszcza go w drugim bloku danych
We:
    Adresy na oba bloki danych
Wy:
    wyliczony blok autoryzacji zapisany do drugiego bloku danych

*****************************************************************************/
void TVTT_Calc(BYTE *DataA, BYTE*DataB)
{
    int     SrcPtr;
    int     DstPtr;

    // wypenienie bloku kontrolnego wartoci 0xFF
    DstPtr=0;
    while (DstPtr<12)
        {
        DataB[TVTTD_AUTH+DstPtr]=0xFF;
        DstPtr++;
        };

    // doczenie do obszaru kontrolnego, danych pierwszego bloku danych
    DstPtr=0;

    SrcPtr=0;
    while(SrcPtr<16)
        {
        DataB[TVTTD_AUTH+DstPtr]^=DataA[SrcPtr];
        DstPtr=(DstPtr+1)%12;
        SrcPtr++;
        };

    // doczenie do obszaru kontrolnego, danych drugiego bloku danych
    SrcPtr=0;
    while(SrcPtr<TVTTD_AUTH)
        {
        DataB[TVTTD_AUTH+DstPtr]^=DataB[SrcPtr];
        DstPtr=(DstPtr+1)%12;
        SrcPtr++;
        };
};


/*****************************************************************************
Funkcja sprawdza poprawno bloku kontrolnego wiadomoci
We:
    Adresy na oba bloki danych
Wy:
    0 - blok kontrolny poprawny lub !0 - blok kontrolny nie poprawny

*****************************************************************************/
BYTE TVTT_Check(BYTE *DataA, BYTE*DataB)
{
    int     SrcPtr;
    int     DstPtr;

    // "usunicie" z obszaru kontrolnego, danych pierwszego bloku danych
    DstPtr=0;

    SrcPtr=0;
    while(SrcPtr<16)
        {
        DataB[TVTTD_AUTH+DstPtr]^=DataA[SrcPtr];
        DstPtr=(DstPtr+1)%12;
        SrcPtr++;
        };

    // "usunicie" z obszaru kontrolnego, danych drugiego bloku danych
    SrcPtr=0;
    while(SrcPtr<TVTTD_AUTH)
        {
        DataB[TVTTD_AUTH+DstPtr]^=DataB[SrcPtr];
        DstPtr=(DstPtr+1)%12;
        SrcPtr++;
        };

    // sprawdzenie czy blok kontrolny wypeniony wartoci 0xFF
    DstPtr=0;
    while (DstPtr<12)
        {
        if (DataB[TVTTD_AUTH+DstPtr]!=0xFF) return(!0);                     // bd w bloku kontrolnym
        DstPtr++;
        };

    return(0);                                                              // blok kontrolny poprawny
};


/*****************************************************************************
Funkcja wylicza klucz sesji
We:
    Adres na wyliczony klucz sesji (adres na tablic docelow)
    Haso PC
    Tablica losowa PC
    Haso Tokenu
    Tablica losowa Tokenu
Wy:
    wyliczony klucz sesji wpisany do podanej tablicy

*****************************************************************************/
void TVTT_CalcSessionKey(BYTE SessionKey[16], BYTE PassPC[16], BYTE RandPC[16], BYTE PassT[16], BYTE RandT[16])
{
    int     i;
    BYTE    Data[16];

    i=0;                                                                    // skopiowanie tablicy losowej PC do bufora
    while(i<16)
        {
        Data[i]=RandPC[i];
        i++;
        };

    rijndaelEncrypt(PassT,Data);                                            // zaszyfrowanie tablicy losowej PC hasem Tokenu

    i=0;                                                                    // przepisanie uzyskanej czsci klucza do tablicy klucza sesji
    while(i<16)
        {
        SessionKey[i]=Data[i];
        i++;
        };

    i=0;                                                                    // skopiowanie tablicy losowej Tokenu do bufora
    while(i<16)
        {
        Data[i]=RandT[i];
        i++;
        };

    rijndaelEncrypt(PassPC,Data);                                           // zaszyfrowanie tablicy losowej Tokenu hasem PC

    i=0;                                                                    // poczenie pierwszej czsci klucza sesji z uzyskan drug czsci klucza sesji
    while(i<16)
        {
        SessionKey[i]^=Data[i];
        i++;
        };

    i=0;                                                                    // wyczyszczenie bufora pomocniczego
    while(i<16)
        {
        Data[i]=0;
        i++;
        };
};

/*****************************************************************************
Funkcja rozszyfrowuje lub szyfruje podany blok danych
We:
    Adres na blok do zaszyfrowania
    Klucza szyfrowania wiadomoci
    Haso sesji
    Numer bloku danych (0-blok pierwszy, 1-blok drugi)
    Kierunek przesyania wiadomoci (0 - PC->Token, 1 - Token->PC)
Wy:
    zaszyfrowany blok danych

*****************************************************************************/
void TVTT_CryptBlock(BYTE Block[16], DWORD Key, BYTE Pass[16], BYTE BlockNr, BYTE Direction)
{
    int     i;
    BYTE    HashTable[16];

    if (!Key) return;                                                       // Key=0 jest znacznikiem wiadomoci nieszyfrowanej -> wyjcie

    i=0;                                                                    // wyczyszczenie tablicy mieszajcej
    while(i<16)
        {
        HashTable[i]=0;
        i++;
        };

    HashTable[0]=(BYTE)Key;                                                 // przygotowanie do generowania klucza tymczasowego - wpisanie klucza szyfrowania wiadomoci do tablicy wynikowej
    Key=Key>>8;
    HashTable[1]=(BYTE)Key;
    Key=Key>>8;
    HashTable[2]=(BYTE)Key;

    HashTable[3]=(BYTE)BlockNr;                                             // przygotowanie do gewnerowania klucza tymczasowego - doczenie numeru bloku danych
    HashTable[4]=(BYTE)Direction;                                           // przygotowanie do gewnerowania klucza tymczasowego - doczenie znacznika kierunku przesyu wiadomoci
    rijndaelEncrypt(Pass,HashTable);                                        // wygenerowanie hasa tymczasowego

    i=0;                                                                    // rozszyfrowanie lub zaszyfrowanie bloku oraz wyczyszczenie tablicy mieszajcej
    while(i<16)
        {
        Block[i]^=HashTable[i];
        HashTable[i]=0;
        i++;
        };
};

/*****************************************************************************
Funkcja dodaje zdarzenia losowe do generatora liczb pseudolosowych
We:
    Numer rda zdarze losowych
    Warto zdarzenia

*****************************************************************************/

void TVTT_Randomize(BYTE SrcNr,DWORD Data)
{
BYTE Buff[16];
BYTE n;
DWORD RandOffset;

// zwikszenie licznika danych w kolejce
if (RandRandCnt[RandRandNr[SrcNr&0xFF]&31]!=0xFFFFFFFF)
    (RandRandCnt[RandRandNr[SrcNr&0xFF]&31])++;

// wyliczenie offsetu na kolejke i zwikszenie licznika kolejek
RandOffset=(RandRandNr[SrcNr&0xFF]&31)*16;
RandRandNr[SrcNr]=(RandRandNr[SrcNr]+1)&31;

// wyczyszczenie bufora i wpisanie do niego danych o zdarzeniu
n=0;
while (n<16)
    {
    Buff[n]=0;
    n++;
    };

Buff[0]=SrcNr;
Buff[1]=(BYTE)Data;
Data=Data>>8;
Buff[2]=(BYTE)Data;
Data=Data>>8;
Buff[3]=(BYTE)Data;
Data=Data>>8;
Buff[4]=(BYTE)Data;

// pomieszanie danych o zdarzeniu z danymi z kolejki
rijndaelEncrypt(RandRand+RandOffset,Buff);

// wpisanie nowych danych do kolejki i zamazanie zawartoci bufora
n=0;
while (n<16)
    {
    RandRand[n+RandOffset]=Buff[n];
    Buff[n]=0;
    n++;
    };
};

/*****************************************************************************
Funkcja generuje 16-bajtowy blok pseudolosowy
We:
    Adres na blok do wypenienia wartociami losowymi
Wy:
    blok danych pseudolosowych

*****************************************************************************/

void TVTT_Rand(BYTE Rand[16])
{
DWORD n;
BYTE i;
BYTE NewKeyA[16];
BYTE NewKeyB[16];

// obsuga mieszania z danymi losowymi

n=0;
while (n<32)                                                                // przejrzenie wszystkich kolejek pod kontem iloci zdarze w kolejce
    {
    if (RandRandCnt[n]>(1UL<<n))                                            // sprawdzenie czy wystarczajco duzo zdarze
        {                                                                   //  jesli do zdarze to wymieszanie zdarze z kluczem generacji
        // przekopiowanie aktualnych zdarze i wyczyszczenie kolejki
        i=0;        
        while (i<8)
            {
            NewKeyA[i]=RandRand[i+(n*16)];
            NewKeyB[i]=RandRand[i+8+(n*16)];
            NewKeyA[i+8]=0;
            NewKeyB[i+8]=0;
            RandRand[i+(n*16)]=0;
            RandRand[i+8+(n*16)]=0;
            i++;
            };

        // wygenerowanie nowego klucza
        rijndaelEncrypt(RandKeyA,NewKeyA);
        rijndaelEncrypt(RandKeyB,NewKeyB);

        // zapisanie nowych kluczy generacji i wyczyszczenie buforw pomocniczych
        i=0;
        while (i<16)
            {
            RandKeyA[i]=NewKeyA[i];
            RandKeyB[i]=NewKeyB[i];
            NewKeyA[i]=0;
            NewKeyB[i]=0;
            i++;
            };
        };
    n++;
    };

// przekopiowanie aktualnego stanu licznika
n=0;        
while (n<16)
    {
    Rand[n]=RandCnt[n];
    n++;
    };

// zwikszenie licznika
RandCnt[0]++;                                                               // zwikszenie najmlodszego bajtu
n=1;
while(n<16)                                                                 // sprawdzenie przeniesienia na starszy bajt
    {
    if (!RandCnt[n-1])                                                      // sprawdzenie czy modszy bajt wyzerowany
        RandCnt[n]++;                                                       //  wyzerowany - moliwe tylko gdy nastpio przeniesienie -> zwikszenie starszego bajtu
    else
        break;                                                              // nie wyzerowany - nie wystpio przeniesienie -> koniec ptli
    n++;
    };

// wygenerowanei wartoci wyjciowej (pseudolosowej)
rijndaelEncrypt(RandKeyA,Rand);
rijndaelEncrypt(RandKeyB,Rand);

// wygenerowanie nowego pierwszego klucza

// przekopiowanie aktualnego stanu licznika
n=0;        
while (n<16)
    {
    NewKeyA[n]=RandCnt[n];
    n++;
    };

// zwikszenie licznika
RandCnt[0]++;                                                               // zwikszenie najmlodszego bajtu
n=1;
while(n<16)                                                                 // sprawdzenie przeniesienia na starszy bajt
    {
    if (!RandCnt[n-1])                                                      // sprawdzenie czy modszy bajt wyzerowany
        RandCnt[n]++;                                                       //  wyzerowany - moliwe tylko gdy nastpio przeniesienie -> zwikszenie starszego bajtu
    else
        break;                                                              // nie wyzerowany - nie wystpio przeniesienie -> koniec ptli
    n++;
    };

// wygenerowanie nowego klucza
rijndaelEncrypt(RandKeyA,NewKeyA);
rijndaelEncrypt(RandKeyB,NewKeyA);

// wygenerowanie nowego drugiego klucza

// przekopiowanie aktualnego stanu licznika
n=0;        
while (n<16)
    {
    NewKeyB[n]=RandCnt[n];
    n++;
    };

// zwikszenie licznika
RandCnt[0]++;                                                               // zwikszenie najmlodszego bajtu
n=1;
while(n<16)                                                                 // sprawdzenie przeniesienia na starszy bajt
    {
    if (!RandCnt[n-1])                                                      // sprawdzenie czy modszy bajt wyzerowany
        RandCnt[n]++;                                                       //  wyzerowany - moliwe tylko gdy nastpio przeniesienie -> zwikszenie starszego bajtu
    else
        break;                                                              // nie wyzerowany - nie wystpio przeniesienie -> koniec ptli
    n++;
    };

// wygenerowanie nowego klucza
rijndaelEncrypt(RandKeyA,NewKeyB);
rijndaelEncrypt(RandKeyB,NewKeyB);

// zapamitanie nowych kluczy i wyczyszczenie buforw pomocniczych
n=0;
while (n<16)
    {
    RandKeyA[n]=NewKeyA[n];
    RandKeyB[n]=NewKeyB[n];
    NewKeyA[n]=0;
    NewKeyB[n]=0;
    n++;
    };
};

/*****************************************************************************
Funkcja inicjuje generator liczb pseudolosowych
We:
    Adres na blok danych inicjujcych

*****************************************************************************/

void TVTT_RandInit(BYTE Init[16*4])
{
DWORD n;

// rozszyfrowanie tablic
n=1;
while(n<4)
    {
    rijndaelDecrypt(Init,Init+(n*16));
    n++;
    };

// usunicie mieszania tablic
n=16;
while(n<(16*4))
    {
    Init[n]^=n;
    n++;
    };

// przepisanie danych z bloku do tablic
n=0;
while (n<16)
    {
    RandKeyA[n]=Init[n+16];
    RandKeyB[n]=Init[n+32];
    RandCnt[n]=Init[n+48];
    n++;
    };
};

/*****************************************************************************
Funkcja zwraca blok danych do uycia przy nastpnej inicjalizacji generatora
    liczb pseudolosowych
We:
    Adres na blok do ktrego zapis danych opisujcych stan generatora
Wy:
    Blok danych opisujcych stan generatora

*****************************************************************************/

void TVTT_RandGetInit(BYTE Init[16*4])
{
TVTT_Rand(Init+ 0);
TVTT_Rand(Init+16);
TVTT_Rand(Init+32);
TVTT_Rand(Init+48);
};

