#include <windows.h>
#include <stdio.h>
#include "rijndael-alg-ref.h "
#include "TeleToken.h"
#include "TeleTokenAPI.h"

BYTE    TVTTAPI_Int_Name[]="Software\\App Data\\Seed";
DWORD   TVTTAPI_Int_LastUpdate=0;

typedef struct 
    {
    BYTE    Rand[16];
    BYTE    RandPC[16];
    BYTE    RandT[16];
    BYTE    Key[16];
    DWORD   hToken;
    DWORD   OutKey;
    DWORD   InKey;
    DWORD   TokenInfo[256];
    DWORD   TokenInfoSize;
    } TVTTAPI_INT_CON;

/*****************************************************************************
Funkcja wewntrzna - szyfruje strukture opisujc poczenie
We:
    Adres na klucz szyfrowania
    Adres na strukture do zaszyfrowania
Wy:
*****************************************************************************/

void TVTTAPI_Int_CodeCon(BYTE Pass[16],TVTTAPI_INT_CON *Con)
{
DWORD    n,i;
BYTE    *Ptr=(BYTE*) Con;

TVTT_Rand(Ptr);

n=16;
while (n<(((sizeof(TVTTAPI_INT_CON)+15)/16)*16))
    {
    i=0;
    while(i<16)
        {
        Ptr[n+i]^=Ptr[n+i-16];
        i++;
        };

    rijndaelEncrypt(Pass,Ptr+n);
    n+=16;
    };
};

/*****************************************************************************
Funkcja wewntrzna - rozszyfruje strukture opisujc poczenie
We:
    Adres na klucz szyfrowania
    Adres na strukture do zaszyfrowania
Wy:
*****************************************************************************/

void TVTTAPI_Int_DecodeCon(BYTE Pass[16],TVTTAPI_INT_CON *Con)
{
DWORD    n,i;
BYTE    *Ptr=(BYTE*) Con;

n=(((sizeof(TVTTAPI_INT_CON)+15)/16)*16)-16;
while (n>15)
    {   
    rijndaelDecrypt(Pass,Ptr+n);
    i=0;
    while(i<16)
        {
        Ptr[n+i]^=Ptr[n+i-16];
        i++;
        };

    n-=16;
    };
};

/*****************************************************************************
Funkcja wewntrzna - na podstawie zwrconego kodu bdu ustawia "LastError"
We:
    kod bdu
Wy:
    ustawiony "LastError"
*****************************************************************************/

void TVTTAPI_Int_SetLastError(DWORD Res)
{
switch (Res&0xFF00)
    {
    case TVTTS_TOO_MANY_OPEN_TOKENS:
        SetLastError(ERROR_TOO_MANY_OPEN_FILES);
        return;

    case TVTTS_USB_DOES_NOT_EXIST:
        SetLastError(ERROR_UNKNOWN_PORT);
        return;

    case TVTTS_TOKEN_NOT_FOUND:
        SetLastError(ERROR_NOT_FOUND);
        return;

    case TVTTS_TIME_OUT:
        SetLastError(ERROR_TIMEOUT);
        return;

    case TVTTS_EXPIRED:
        SetLastError(ERROR_ACCOUNT_EXPIRED);
        return;

    case TVTTS_ALREADY_OPENED:
        SetLastError(ERROR_ALREADY_INITIALIZED);
        return;

	case TVTTS_DLL_INIT_FAILED:
		SetLastError(ERROR_DLL_NOT_FOUND);
		return;

    case TVTTS_UNKNOWN_ERROR:
    case TVTTS_NULL_PTR:
    case TVTTS_BAD_PARAM:
    case TVTTS_INVALID_HANDLE:
        SetLastError(ERROR_UNEXP_NET_ERR);
        return;
    };

switch (Res&0xFF)
    {
    case TVTTS_NO_OPEN:
        SetLastError(ERROR_ACCOUNT_EXPIRED);
        return;

    case TVTTS_EXPIRED:
        SetLastError(ERROR_TIMEOUT);
        return;

    case TVTTS_DAMAGED:
        SetLastError(ERROR_GEN_FAILURE);
        return;

    case TVTTS_NOT_SUPPORTED:
        SetLastError(ERROR_NOT_SUPPORTED);
        return;

    case TVTTS_OUT_OF_RANGE:
        SetLastError(ERROR_INVALID_BLOCK);
        return;

    case TVTTS_PROTECTION_NOT_SUPPORTED:
        SetLastError(ERROR_SET_NOT_FOUND);
        return;

    case TVTTS_PASS_NOT_PERMITTED:
        SetLastError(ERROR_INVALID_PASSWORD);
        return;
     
    case TVTTS_NOT_PERMITTED:
        SetLastError(ERROR_ACCESS_DENIED);
        return;

    case TVTTS_ACCESS_EXPIRED:
        SetLastError(ERROR_COUNTER_TIMEOUT);
        return;
    };

if (Res)
    SetLastError(ERROR_UNEXP_NET_ERR);
else
    SetLastError(ERROR_SUCCESS);

};

/*****************************************************************************
Funkcja wewntrzna - testuje poprawnoc komunikacji
We:
    kod bdu
Wy:
	0 - bez bedw / !0 - wystapi bd
    ustawiony "LastError"
*****************************************************************************/

BYTE TVTTAPI_Int_CheckError(TVTTAPI_INT_CON *Con, DWORD Res, DWORD InKey, BYTE InDataA[16], BYTE InDataB[16])
{
if (Res)
    {
    TVTTAPI_Int_SetLastError(Res);
    return(!0);
    };

if (!InKey)
    {
	if (TVTT_Check(InDataA,InDataB))
	    SetLastError(ERROR_CRC);
	else
		{
		if (InDataB[TVTTD_STATUS])
		    TVTTAPI_Int_SetLastError(InDataB[TVTTD_STATUS]);
		else
		    SetLastError(ERROR_UNEXP_NET_ERR);
		};
	return(!0);
	}
else
	{
	if (Con->InKey&0xFF000000)
		Con->InKey=InKey;
	else
		{
		if (InKey!=Con->InKey)
			{
		    SetLastError(ERROR_UNEXP_NET_ERR);
			return(!0);
			};
		};
	Con->InKey=((Con->InKey+1)&0xFFFFFF);
	};

if (TVTT_Check(InDataA,InDataB))
    {
    SetLastError(ERROR_CRC);
    return(!0);
    };

if (InDataB[TVTTD_STATUS])
    {
    TVTTAPI_Int_SetLastError(InDataB[TVTTD_STATUS]);
    return(!0);
    };

return(0);
};

/*****************************************************************************
Funkcja inicjalizuje bibliotek
We:
Wy:
*****************************************************************************/

void TVTTAPI_Initialize(void)
{
BYTE    InitTab[TVTT_RAND_INIT_TBL_SIZE];
HKEY    hKey;
DWORD   Res;
LONG    l;
DWORD   n,i;

n=0;
while (n<TVTT_RAND_INIT_TBL_SIZE)
    {
    InitTab[n]=(BYTE)GetTickCount();
    n++;
    };

l=RegCreateKeyEx(HKEY_CURRENT_USER,TVTTAPI_Int_Name,0,NULL,REG_OPTION_NON_VOLATILE,KEY_QUERY_VALUE|KEY_SET_VALUE,NULL,&hKey,&Res);
if ((l==ERROR_SUCCESS)&&(Res==REG_OPENED_EXISTING_KEY))
    {
    n=TVTT_RAND_INIT_TBL_SIZE;
    i=REG_BINARY;
    RegQueryValueEx(hKey,NULL,NULL,&i,InitTab,&n);
    };

TVTT_RandInit(InitTab);

TVTT_RandGetInit(InitTab);
RegSetValueEx(hKey,NULL,0,REG_BINARY,InitTab,TVTT_RAND_INIT_TBL_SIZE);

if (l==ERROR_SUCCESS) RegCloseKey(hKey);

ZeroMemory(InitTab,TVTT_RAND_INIT_TBL_SIZE);
SetLastError(ERROR_SUCCESS);
return;
};

/*****************************************************************************
Funkcja dodaje zdarzenia do generatora liczb pseudolosowych
We:
    Adres na wiadomo systemow
Wy:
*****************************************************************************/

void TVTTAPI_Randomize(MSG *Msg)
{
BYTE    InitTab[TVTT_RAND_INIT_TBL_SIZE];
BYTE    n=0xFF;
DWORD   Time;
LONG    l;
HKEY    hKey;
DWORD   Res;

switch (Msg->message)
    {
    case WM_KEYUP:
        n=0;
        break;

    case WM_KEYDOWN:
        n=1;
        break;

    case WM_MOUSEMOVE:
        n=2;
        break;

    case WM_LBUTTONDOWN:
        n=3;
        break;

    case WM_LBUTTONUP:
        n=4;
        break;

    case WM_MBUTTONDOWN:
        n=5;
        break;

    case WM_MBUTTONUP:
        n=6;
        break;

    case WM_RBUTTONDOWN:
        n=7;
        break;

    case WM_RBUTTONUP:
        n=8;
        break;
    };

if ((n*3)<31)
    {
    TVTT_Randomize((n*3)+0,Msg->time);
    TVTT_Randomize((n*3)+1,(DWORD)Msg->wParam);
    TVTT_Randomize((n*3)+2,(DWORD)Msg->lParam);
    };

Time=GetTickCount();
if (TVTTAPI_Int_LastUpdate&0x80000000)
    {
    if (Time&0x80000000)
        {
        if ((TVTTAPI_Int_LastUpdate+10000)<TVTTAPI_Int_LastUpdate) return;
        if (Time<(TVTTAPI_Int_LastUpdate+10000)) return;
        };
    }
else
    {
    if (Time<(TVTTAPI_Int_LastUpdate+10000)) return;  
    };
TVTTAPI_Int_LastUpdate=Time;

l=RegCreateKeyEx(HKEY_CURRENT_USER,TVTTAPI_Int_Name,0,NULL,REG_OPTION_NON_VOLATILE,KEY_QUERY_VALUE|KEY_SET_VALUE,NULL,&hKey,&Res);
if ((l==ERROR_SUCCESS)&&(Res==REG_OPENED_EXISTING_KEY))
    {
    TVTT_RandGetInit(InitTab);
    RegSetValueEx(hKey,NULL,0,REG_BINARY,InitTab,TVTT_RAND_INIT_TBL_SIZE);
    };
if (l==ERROR_SUCCESS) RegCloseKey(hKey);

ZeroMemory(InitTab,TVTT_RAND_INIT_TBL_SIZE);
return;
};

/*****************************************************************************
Funkcja wypenia podany blok wartoci pseudolosow
We:
    Adres na tablice do wypenienia
Wy:
*****************************************************************************/

void TVTTAPI_Rand(BYTE Random[16])
{
if (!Random)
    {
    SetLastError(ERROR_INVALID_DATA);
    return;
    };
TVTT_Rand(Random);
SetLastError(ERROR_SUCCESS);
};

/*****************************************************************************
Funkcja znajduje Token i otwiera poczenie z Tokenem
We:
    Adres na 16-bajtowy klucz do poczenia
    ID odbiorcy tokenu
    Maska odbiorcy tokenu
    Ilo Tokenw do pominicia
Wy:
    uchwyt na poczenie z tokenem lub NULL jeli bd
    ustawiony "LastError"
*****************************************************************************/

void * TVTTAPI_Open(BYTE Pass[16],DWORD OwnerID,BYTE OwnerMsk,BYTE Skip)
{
DWORD            Res;
TVTTAPI_INT_CON   *Con;

if(!Pass)
    {
    SetLastError(ERROR_INVALID_DATA);
    return(NULL);
    };

Con=GlobalAlloc(GPTR,((sizeof(TVTTAPI_INT_CON)+15)/16)*16);
if (!Con) return(NULL);

Con->TokenInfoSize=256;
Res=TVTT_FindToken(&(Con->hToken),5*10,OwnerID,OwnerMsk,Skip,&(Con->TokenInfoSize),Con->TokenInfo);
if (Res)
    {
    TVTTAPI_Int_SetLastError(Res);
    ZeroMemory(Con,((sizeof(TVTTAPI_INT_CON)+15)/16)*16);
    GlobalFree(Con);
    return(NULL);
    };
TVTTAPI_Int_CodeCon(Pass,Con);
SetLastError(ERROR_SUCCESS);
return(Con);
};

/*****************************************************************************
Funkcja zamyka poczenie z Tokenem i zwalnia zasoby
We:
    Adres na 16-bajtowy klucz do poczenia
    Uchwyt na poczenie
Wy:
    ustawiony "LastError"
*****************************************************************************/

void TVTTAPI_Close(BYTE Pass[16],void *hCon)
{
TVTTAPI_INT_CON   *Con=(TVTTAPI_INT_CON*) hCon;
DWORD Res;

if((!Pass)||(!hCon))
    {
    SetLastError(ERROR_INVALID_DATA);
    return;
    };

TVTTAPI_Int_DecodeCon(Pass,Con);

Res=TVTT_FreeToken(Con->hToken);
if (Res)
    {
    TVTTAPI_Int_CodeCon(Pass,Con);
    TVTTAPI_Int_SetLastError(Res);
    return;
    };

ZeroMemory(Con,((sizeof(TVTTAPI_INT_CON)+15)/16)*16);
GlobalFree(Con);
SetLastError(ERROR_SUCCESS);
};

/*****************************************************************************
Funkcja zwraca warto opisujc konkretn waciwo Tokenu
We:
    Adres na 16-bajtowy klucz do poczenia
    Uchwyt na poczenie
    Numer waciwoci Tokenu
Wy:
    waciwo Tokenu
    ustawiony "LastError"
*****************************************************************************/

DWORD TVTTAPI_GetFeature(BYTE Pass[16],void *hCon,DWORD FNr)
{
TVTTAPI_INT_CON   *Con=(TVTTAPI_INT_CON*) hCon;
DWORD Res=0;

if((!Pass)||(!hCon))
    {
    SetLastError(ERROR_INVALID_DATA);
    return(0);
    };

TVTTAPI_Int_DecodeCon(Pass,Con);

if (FNr>=Con->TokenInfoSize)
    Res=0;
else
    Res=Con->TokenInfo[FNr];

TVTTAPI_Int_CodeCon(Pass,Con);

SetLastError(ERROR_SUCCESS);
return(Res);
};

/*****************************************************************************
Funkcja rozpoczyna sesj z tokenem
We:
    Adres na 16-bajtowy klucz do poczenia
    Uchwyt na poczenie
    Numer hasa proponowanego przez PC
Wy:
    Numer hasa zaproponowanego przez Token
    ustawiony "LastError"
*****************************************************************************/

BYTE TVTTAPI_StartSession(BYTE Pass[16],void *hCon,BYTE PCPassNr)
{
TVTTAPI_INT_CON   *Con=(TVTTAPI_INT_CON*) hCon;
DWORD   Res;
BYTE    TPassNr=0;
BYTE    OutData[16];
BYTE    InData[16];
DWORD   InKey;

if((!Pass)||(!hCon))
    {
    SetLastError(ERROR_INVALID_DATA);
    return(0);
    };

TVTTAPI_Int_DecodeCon(Pass,Con);

Res=TVTT_StartSession(Con->hToken,1);
if (Res)
    {
    TVTTAPI_Int_CodeCon(Pass,Con);
    TVTTAPI_Int_SetLastError(Res);
    return(0);
    };

ZeroMemory(Con->RandPC,16);
ZeroMemory(OutData,16);
ZeroMemory(Con->RandT,16);
ZeroMemory(InData,16);

Con->OutKey=0;
Con->InKey=0xFFFFFFFF;

TVTT_Rand(Con->RandPC);
OutData[TVTTD_CMD]=TVTTC_OPEN;
OutData[TVTTD_PARAM1]=PCPassNr;

TVTT_Calc(Con->RandPC,OutData);
Res=TVTT_Talk(Con->hToken,5,Con->OutKey,Con->RandPC,OutData,&InKey,Con->RandT,InData);
if (Res)
    {
    InKey=0;
    ZeroMemory(Con->RandPC,16);
    ZeroMemory(OutData,16);
    ZeroMemory(Con->RandT,16);
    ZeroMemory(InData,16);
    TVTT_EndSession(Con->hToken);
    TVTTAPI_Int_CodeCon(Pass,Con);
    TVTTAPI_Int_SetLastError(Res);
    return(0);
    };

if (InKey)
    {
    InKey=0;
    ZeroMemory(Con->RandPC,16);
    ZeroMemory(OutData,16);
    ZeroMemory(Con->RandT,16);
    ZeroMemory(InData,16);
    TVTT_EndSession(Con->hToken);
    TVTTAPI_Int_CodeCon(Pass,Con);
    SetLastError(ERROR_UNEXP_NET_ERR);
    return(0);
    };

if (TVTT_Check(Con->RandT,InData))
    {
    InKey=0;
    ZeroMemory(Con->RandPC,16);
    ZeroMemory(OutData,16);
    ZeroMemory(Con->RandT,16);
    ZeroMemory(InData,16);
    TVTT_EndSession(Con->hToken);
    TVTTAPI_Int_CodeCon(Pass,Con);
    SetLastError(ERROR_CRC);
    return(0);
    };

if (InData[TVTTD_STATUS])
    {
    TVTT_EndSession(Con->hToken);
    TVTTAPI_Int_CodeCon(Pass,Con);
    TVTTAPI_Int_SetLastError(InData[TVTTD_STATUS]);
    InKey=0;
    ZeroMemory(Con->RandPC,16);
    ZeroMemory(OutData,16);
    ZeroMemory(Con->RandT,16);
    ZeroMemory(InData,16);
    return(0);
    };

TPassNr=InData[TVTTD_PARAM1];

ZeroMemory(OutData,16);
ZeroMemory(InData,16);
InKey=0;

TVTT_Rand(OutData);
Con->OutKey=OutData[0];
Con->OutKey=Con->OutKey<<8;
Con->OutKey|=OutData[1];
Con->OutKey=Con->OutKey<<8;
Con->OutKey|=OutData[2];
Con->OutKey=Con->OutKey<<8;
ZeroMemory(OutData,16);

TVTTAPI_Int_CodeCon(Pass,Con);

SetLastError(ERROR_SUCCESS);
return(TPassNr);
};


/*****************************************************************************
Funkcja koczy sesj z tokenem
We:
    Adres na 16-bajtowy klucz do poczenia
    Uchwyt na poczenie
Wy:
    ustawiony "LastError"
*****************************************************************************/

void TVTTAPI_EndSession(BYTE Pass[16],void *hCon)
{
TVTTAPI_INT_CON   *Con=(TVTTAPI_INT_CON*) hCon;
DWORD   Res,Res2;

BYTE    OutDataA[16];
BYTE    OutDataB[16];
BYTE    InDataA[16];
BYTE    InDataB[16];
DWORD   InKey;

if((!Pass)||(!hCon))
    {
    SetLastError(ERROR_INVALID_DATA);
    return;
    };

TVTTAPI_Int_DecodeCon(Pass,Con);

ZeroMemory(OutDataA,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

Con->OutKey++;
OutDataB[TVTTD_CMD]=TVTTC_CLOSE;

TVTT_Calc(OutDataA,OutDataB);
TVTT_CryptBlock(OutDataA,Con->OutKey,Con->Key,TVTT_BLOCK_A,TVTT_PC2T);
TVTT_CryptBlock(OutDataB,Con->OutKey,Con->Key,TVTT_BLOCK_B,TVTT_PC2T);
Res=TVTT_Talk(Con->hToken,5,Con->OutKey,OutDataA,OutDataB,&InKey,InDataA,InDataB);
if (Res) TVTTAPI_Int_SetLastError(Res);

Res2=TVTT_EndSession(Con->hToken);
if ((!Res)&&Res2) TVTTAPI_Int_SetLastError(Res2);

Con->OutKey=0;
ZeroMemory(Con->Key,16);

TVTTAPI_Int_CodeCon(Pass,Con);

ZeroMemory(OutDataA,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);
InKey=0;

SetLastError(ERROR_SUCCESS);
return;
};

/*****************************************************************************
Funkcja wylicza haso sesji na podstawie zaproponowanych hase
We:
    Adres na 16-bajtowy klucz do poczenia
    Uchwyt na poczenie
    Haso proponowane przez PC
    Haso proponowane przez T
Wy:
    ustawiony "LastError"
*****************************************************************************/

void TVTTAPI_CalcPass(BYTE Pass[16],void *hCon,BYTE PassPC[16],BYTE PassT[16])
{
TVTTAPI_INT_CON   *Con=(TVTTAPI_INT_CON*) hCon;

if((!Pass)||(!hCon)||(!PassPC)||(!PassT))
    {
    SetLastError(ERROR_INVALID_DATA);
    return;
    };

TVTTAPI_Int_DecodeCon(Pass,Con);

TVTT_CalcSessionKey(Con->Key,PassPC,Con->RandPC,PassT,Con->RandT);

ZeroMemory(Con->RandPC,16);
ZeroMemory(Con->RandT,16);

TVTTAPI_Int_CodeCon(Pass,Con);

SetLastError(ERROR_SUCCESS);
return;
};

/*****************************************************************************
Funkcja odczytuje sektor z pamici nieulotnej
We:
    Adres na 16-bajtowy klucz do poczenia
    Uchwyt na poczenie
    Numer sektora do odczytania
    Adres na bufor na sektor
Wy:
    wypeniony bufor na sektor
    ustawiony "LastError"
*****************************************************************************/

void TVTTAPI_MemRead(BYTE Pass[16],void *hCon,BYTE SNr,BYTE Buff[16])
{
TVTTAPI_INT_CON   *Con=(TVTTAPI_INT_CON*) hCon;
DWORD   Res;

BYTE    OutDataA[16];
BYTE    OutDataB[16];
BYTE    InDataA[16];
BYTE    InDataB[16];
DWORD   InKey;

if((!Pass)||(!hCon)||(!Buff))
    {
    SetLastError(ERROR_INVALID_DATA);
    return;
    };

ZeroMemory(Buff,16);

TVTTAPI_Int_DecodeCon(Pass,Con);

ZeroMemory(OutDataA,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

Con->OutKey++;
OutDataB[TVTTD_CMD]=TVTTC_NVMEM_READ;
OutDataB[TVTTD_PARAM1]=SNr;

TVTT_Calc(OutDataA,OutDataB);
TVTT_CryptBlock(OutDataA,Con->OutKey,Con->Key,TVTT_BLOCK_A,TVTT_PC2T);
TVTT_CryptBlock(OutDataB,Con->OutKey,Con->Key,TVTT_BLOCK_B,TVTT_PC2T);
Res=TVTT_Talk(Con->hToken,5,Con->OutKey,OutDataA,OutDataB,&InKey,InDataA,InDataB);
TVTT_CryptBlock(InDataA,InKey,Con->Key,TVTT_BLOCK_A,TVTT_T2PC);
TVTT_CryptBlock(InDataB,InKey,Con->Key,TVTT_BLOCK_B,TVTT_T2PC);
if (TVTTAPI_Int_CheckError(Con,Res,InKey,InDataA,InDataB))
    {
    InKey=0;
    ZeroMemory(OutDataA,16);
    ZeroMemory(OutDataB,16);
    ZeroMemory(InDataA,16);
    ZeroMemory(InDataB,16);
    TVTTAPI_Int_CodeCon(Pass,Con);
    return;
    };

CopyMemory(Buff,InDataA,16);

TVTTAPI_Int_CodeCon(Pass,Con);

InKey=0;
ZeroMemory(OutDataA,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

SetLastError(ERROR_SUCCESS);
return;
};

/*****************************************************************************
Funkcja odczytuje sektor z pamici ulotnej
We:
    Adres na 16-bajtowy klucz do poczenia
    Uchwyt na poczenie
    Numer sektora do odczytania
    Adres na bufor na sektor
Wy:
    wypeniony bufor na sektor
    ustawiony "LastError"
*****************************************************************************/

void TVTTAPI_RamRead(BYTE Pass[16],void *hCon,BYTE SNr,BYTE Buff[16])
{
TVTTAPI_INT_CON   *Con=(TVTTAPI_INT_CON*) hCon;
DWORD   Res;

BYTE    OutDataA[16];
BYTE    OutDataB[16];
BYTE    InDataA[16];
BYTE    InDataB[16];
DWORD   InKey;

if((!Pass)||(!hCon)||(!Buff))
    {
    SetLastError(ERROR_INVALID_DATA);
    return;
    };

ZeroMemory(Buff,16);

TVTTAPI_Int_DecodeCon(Pass,Con);

ZeroMemory(OutDataA,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

Con->OutKey++;
OutDataB[TVTTD_CMD]=TVTTC_VMEM_READ;
OutDataB[TVTTD_PARAM1]=SNr;

TVTT_Calc(OutDataA,OutDataB);
TVTT_CryptBlock(OutDataA,Con->OutKey,Con->Key,TVTT_BLOCK_A,TVTT_PC2T);
TVTT_CryptBlock(OutDataB,Con->OutKey,Con->Key,TVTT_BLOCK_B,TVTT_PC2T);
Res=TVTT_Talk(Con->hToken,5,Con->OutKey,OutDataA,OutDataB,&InKey,InDataA,InDataB);
TVTT_CryptBlock(InDataA,InKey,Con->Key,TVTT_BLOCK_A,TVTT_T2PC);
TVTT_CryptBlock(InDataB,InKey,Con->Key,TVTT_BLOCK_B,TVTT_T2PC);
if (TVTTAPI_Int_CheckError(Con,Res,InKey,InDataA,InDataB))
    {
    InKey=0;
    ZeroMemory(OutDataA,16);
    ZeroMemory(OutDataB,16);
    ZeroMemory(InDataA,16);
    ZeroMemory(InDataB,16);
    TVTTAPI_Int_CodeCon(Pass,Con);
    return;
    };

CopyMemory(Buff,InDataA,16);

TVTTAPI_Int_CodeCon(Pass,Con);

InKey=0;
ZeroMemory(OutDataA,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

SetLastError(ERROR_SUCCESS);
return;
};

/*****************************************************************************
Funkcja zapisuje sektor do pamici ulotnej
We:
    Adres na 16-bajtowy klucz do poczenia
    Uchwyt na poczenie
    Numer sektora do zapisania
    Adres na bufor z danymi do zapisania
Wy:
    ustawiony "LastError"
*****************************************************************************/

void TVTTAPI_RamWrite(BYTE Pass[16],void *hCon,BYTE SNr,BYTE Buff[16])
{
TVTTAPI_INT_CON   *Con=(TVTTAPI_INT_CON*) hCon;
DWORD   Res;

BYTE    OutDataA[16];
BYTE    OutDataB[16];
BYTE    InDataA[16];
BYTE    InDataB[16];
DWORD   InKey;

if((!Pass)||(!hCon)||(!Buff))
    {
    SetLastError(ERROR_INVALID_DATA);
    return;
    };

TVTTAPI_Int_DecodeCon(Pass,Con);

CopyMemory(OutDataA,Buff,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

Con->OutKey++;
OutDataB[TVTTD_CMD]=TVTTC_VMEM_WRITE;
OutDataB[TVTTD_PARAM1]=SNr;

TVTT_Calc(OutDataA,OutDataB);
TVTT_CryptBlock(OutDataA,Con->OutKey,Con->Key,TVTT_BLOCK_A,TVTT_PC2T);
TVTT_CryptBlock(OutDataB,Con->OutKey,Con->Key,TVTT_BLOCK_B,TVTT_PC2T);
Res=TVTT_Talk(Con->hToken,5,Con->OutKey,OutDataA,OutDataB,&InKey,InDataA,InDataB);
TVTT_CryptBlock(InDataA,InKey,Con->Key,TVTT_BLOCK_A,TVTT_T2PC);
TVTT_CryptBlock(InDataB,InKey,Con->Key,TVTT_BLOCK_B,TVTT_T2PC);
if (TVTTAPI_Int_CheckError(Con,Res,InKey,InDataA,InDataB))
    {
    InKey=0;
    ZeroMemory(OutDataA,16);
    ZeroMemory(OutDataB,16);
    ZeroMemory(InDataA,16);
    ZeroMemory(InDataB,16);
    TVTTAPI_Int_CodeCon(Pass,Con);
    return;
    };

TVTTAPI_Int_CodeCon(Pass,Con);

InKey=0;
ZeroMemory(OutDataA,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

SetLastError(ERROR_SUCCESS);
return;
};

/*****************************************************************************
Funkcja zapisuje sektor do pamici nieulotnej
We:
    Adres na 16-bajtowy klucz do poczenia
    Uchwyt na poczenie
    Numer sektora do zapisania
    Adres na bufor z danymi do zapisania
Wy:
    ustawiony "LastError"
*****************************************************************************/

void TVTTAPI_MemWrite(BYTE Pass[16],void *hCon,BYTE SNr,BYTE Buff[16])
{
TVTTAPI_INT_CON   *Con=(TVTTAPI_INT_CON*) hCon;
DWORD   Res;

BYTE    OutDataA[16];
BYTE    OutDataB[16];
BYTE    InDataA[16];
BYTE    InDataB[16];
DWORD   InKey;

if((!Pass)||(!hCon)||(!Buff))
    {
    SetLastError(ERROR_INVALID_DATA);
    return;
    };

TVTTAPI_Int_DecodeCon(Pass,Con);

CopyMemory(OutDataA,Buff,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

Con->OutKey++;
OutDataB[TVTTD_CMD]=TVTTC_NVMEM_WRITE;
OutDataB[TVTTD_PARAM1]=SNr;

TVTT_Calc(OutDataA,OutDataB);
TVTT_CryptBlock(OutDataA,Con->OutKey,Con->Key,TVTT_BLOCK_A,TVTT_PC2T);
TVTT_CryptBlock(OutDataB,Con->OutKey,Con->Key,TVTT_BLOCK_B,TVTT_PC2T);
Res=TVTT_Talk(Con->hToken,5,Con->OutKey,OutDataA,OutDataB,&InKey,InDataA,InDataB);
TVTT_CryptBlock(InDataA,InKey,Con->Key,TVTT_BLOCK_A,TVTT_T2PC);
TVTT_CryptBlock(InDataB,InKey,Con->Key,TVTT_BLOCK_B,TVTT_T2PC);
if (TVTTAPI_Int_CheckError(Con,Res,InKey,InDataA,InDataB))
    {
    InKey=0;
    ZeroMemory(OutDataA,16);
    ZeroMemory(OutDataB,16);
    ZeroMemory(InDataA,16);
    ZeroMemory(InDataB,16);
    TVTTAPI_Int_CodeCon(Pass,Con);
    return;
    };

TVTTAPI_Int_CodeCon(Pass,Con);

InKey=0;
ZeroMemory(OutDataA,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

SetLastError(ERROR_SUCCESS);
return;
};

/*****************************************************************************
Funkcja zapisuje sektor do pamici nieulotnej i zabezpiecza sektor przed zapisem
We:
    Adres na 16-bajtowy klucz do poczenia
    Uchwyt na poczenie
    Numer sektora do zapisania
    Adres na bufor z danymi do zapisania
Wy:
    ustawiony "LastError"
*****************************************************************************/

void TVTTAPI_MemWriteProtect(BYTE Pass[16],void *hCon,BYTE SNr,BYTE Buff[16])
{
TVTTAPI_INT_CON   *Con=(TVTTAPI_INT_CON*) hCon;
DWORD   Res;

BYTE    OutDataA[16];
BYTE    OutDataB[16];
BYTE    InDataA[16];
BYTE    InDataB[16];
DWORD   InKey;

if((!Pass)||(!hCon)||(!Buff))
    {
    SetLastError(ERROR_INVALID_DATA);
    return;
    };

TVTTAPI_Int_DecodeCon(Pass,Con);

CopyMemory(OutDataA,Buff,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

Con->OutKey++;
OutDataB[TVTTD_CMD]=TVTTC_NVMEM_WRITE_PROTECT;
OutDataB[TVTTD_PARAM1]=SNr;

TVTT_Calc(OutDataA,OutDataB);
TVTT_CryptBlock(OutDataA,Con->OutKey,Con->Key,TVTT_BLOCK_A,TVTT_PC2T);
TVTT_CryptBlock(OutDataB,Con->OutKey,Con->Key,TVTT_BLOCK_B,TVTT_PC2T);
Res=TVTT_Talk(Con->hToken,5,Con->OutKey,OutDataA,OutDataB,&InKey,InDataA,InDataB);
TVTT_CryptBlock(InDataA,InKey,Con->Key,TVTT_BLOCK_A,TVTT_T2PC);
TVTT_CryptBlock(InDataB,InKey,Con->Key,TVTT_BLOCK_B,TVTT_T2PC);
if (TVTTAPI_Int_CheckError(Con,Res,InKey,InDataA,InDataB))
    {
    InKey=0;
    ZeroMemory(OutDataA,16);
    ZeroMemory(OutDataB,16);
    ZeroMemory(InDataA,16);
    ZeroMemory(InDataB,16);
    TVTTAPI_Int_CodeCon(Pass,Con);
    return;
    };

TVTTAPI_Int_CodeCon(Pass,Con);

InKey=0;
ZeroMemory(OutDataA,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

SetLastError(ERROR_SUCCESS);
return;
};

/*****************************************************************************
Funkcja zabezpiecza sektor w pamieci nieulotnej przed zapisem
We:
    Adres na 16-bajtowy klucz do poczenia
    Uchwyt na poczenie
    Numer sektora do zabezpieczenia
Wy:
    ustawiony "LastError"
*****************************************************************************/

void TVTTAPI_MemProtect(BYTE Pass[16],void *hCon,BYTE SNr)
{
TVTTAPI_INT_CON   *Con=(TVTTAPI_INT_CON*) hCon;
DWORD   Res;

BYTE    OutDataA[16];
BYTE    OutDataB[16];
BYTE    InDataA[16];
BYTE    InDataB[16];
DWORD   InKey;

if((!Pass)||(!hCon))
    {
    SetLastError(ERROR_INVALID_DATA);
    return;
    };

TVTTAPI_Int_DecodeCon(Pass,Con);

ZeroMemory(OutDataA,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

Con->OutKey++;
OutDataB[TVTTD_CMD]=TVTTC_NVMEM_PROTECT;
OutDataB[TVTTD_PARAM1]=SNr;

TVTT_Calc(OutDataA,OutDataB);
TVTT_CryptBlock(OutDataA,Con->OutKey,Con->Key,TVTT_BLOCK_A,TVTT_PC2T);
TVTT_CryptBlock(OutDataB,Con->OutKey,Con->Key,TVTT_BLOCK_B,TVTT_PC2T);
Res=TVTT_Talk(Con->hToken,5,Con->OutKey,OutDataA,OutDataB,&InKey,InDataA,InDataB);
TVTT_CryptBlock(InDataA,InKey,Con->Key,TVTT_BLOCK_A,TVTT_T2PC);
TVTT_CryptBlock(InDataB,InKey,Con->Key,TVTT_BLOCK_B,TVTT_T2PC);
if (TVTTAPI_Int_CheckError(Con,Res,InKey,InDataA,InDataB))
    {
    InKey=0;
    ZeroMemory(OutDataA,16);
    ZeroMemory(OutDataB,16);
    ZeroMemory(InDataA,16);
    ZeroMemory(InDataB,16);
    TVTTAPI_Int_CodeCon(Pass,Con);
    return;
    };

TVTTAPI_Int_CodeCon(Pass,Con);

InKey=0;
ZeroMemory(OutDataA,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

SetLastError(ERROR_SUCCESS);
return;
};

/*****************************************************************************
Funkcja szyfruje blok danych o rozmiarze szesnastu bajtw przy uyciu Tokenu
We:
    Adres na 16-bajtowy klucz do poczenia
    Uchwyt na poczenie
    Numer hasa do zaszyfrowania
    Adres na bufor z danymi do zaszyfrowania
Wy:
    zaszyfrowane dane w buforze
    ustawiony "LastError"
*****************************************************************************/

void TVTTAPI_Encrypt(BYTE Pass[16],void *hCon,BYTE PNr,BYTE Buff[16])
{
TVTTAPI_INT_CON   *Con=(TVTTAPI_INT_CON*) hCon;
DWORD   Res;

BYTE    OutDataA[16];
BYTE    OutDataB[16];
BYTE    InDataA[16];
BYTE    InDataB[16];
DWORD   InKey;

if((!Pass)||(!hCon)||(!Buff))
    {
    SetLastError(ERROR_INVALID_DATA);
    return;
    };

TVTTAPI_Int_DecodeCon(Pass,Con);

CopyMemory(OutDataA,Buff,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

Con->OutKey++;
OutDataB[TVTTD_CMD]=TVTTC_ENCRYPT;
OutDataB[TVTTD_PARAM1]=PNr;

TVTT_Calc(OutDataA,OutDataB);
TVTT_CryptBlock(OutDataA,Con->OutKey,Con->Key,TVTT_BLOCK_A,TVTT_PC2T);
TVTT_CryptBlock(OutDataB,Con->OutKey,Con->Key,TVTT_BLOCK_B,TVTT_PC2T);
Res=TVTT_Talk(Con->hToken,5,Con->OutKey,OutDataA,OutDataB,&InKey,InDataA,InDataB);
TVTT_CryptBlock(InDataA,InKey,Con->Key,TVTT_BLOCK_A,TVTT_T2PC);
TVTT_CryptBlock(InDataB,InKey,Con->Key,TVTT_BLOCK_B,TVTT_T2PC);
if (TVTTAPI_Int_CheckError(Con,Res,InKey,InDataA,InDataB))
    {
    InKey=0;
    ZeroMemory(OutDataA,16);
    ZeroMemory(OutDataB,16);
    ZeroMemory(InDataA,16);
    ZeroMemory(InDataB,16);
    TVTTAPI_Int_CodeCon(Pass,Con);
    return;
    };

CopyMemory(Buff,InDataA,16);

TVTTAPI_Int_CodeCon(Pass,Con);

InKey=0;
ZeroMemory(OutDataA,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

SetLastError(ERROR_SUCCESS);
return;
};

/*****************************************************************************
Funkcja deszyfruje blok szesnastu bajtw danych przy uyciu Tokenu
We:
    Adres na 16-bajtowy klucz do poczenia
    Uchwyt na poczenie
    Numer hasa do zaszyfrowania
    Adres na bufor z danymi do zaszyfrowania
Wy:
    zaszyfrowane dane w buforze
    ustawiony "LastError"
*****************************************************************************/

void TVTTAPI_Decrypt(BYTE Pass[16],void *hCon,BYTE PNr,BYTE Buff[16])
{
TVTTAPI_INT_CON   *Con=(TVTTAPI_INT_CON*) hCon;
DWORD   Res;

BYTE    OutDataA[16];
BYTE    OutDataB[16];
BYTE    InDataA[16];
BYTE    InDataB[16];
DWORD   InKey;

if((!Pass)||(!hCon)||(!Buff))
    {
    SetLastError(ERROR_INVALID_DATA);
    return;
    };

TVTTAPI_Int_DecodeCon(Pass,Con);

CopyMemory(OutDataA,Buff,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

Con->OutKey++;
OutDataB[TVTTD_CMD]=TVTTC_DECRYPT;
OutDataB[TVTTD_PARAM1]=PNr;

TVTT_Calc(OutDataA,OutDataB);
TVTT_CryptBlock(OutDataA,Con->OutKey,Con->Key,TVTT_BLOCK_A,TVTT_PC2T);
TVTT_CryptBlock(OutDataB,Con->OutKey,Con->Key,TVTT_BLOCK_B,TVTT_PC2T);
Res=TVTT_Talk(Con->hToken,5,Con->OutKey,OutDataA,OutDataB,&InKey,InDataA,InDataB);
TVTT_CryptBlock(InDataA,InKey,Con->Key,TVTT_BLOCK_A,TVTT_T2PC);
TVTT_CryptBlock(InDataB,InKey,Con->Key,TVTT_BLOCK_B,TVTT_T2PC);
if (TVTTAPI_Int_CheckError(Con,Res,InKey,InDataA,InDataB))
    {
    InKey=0;
    ZeroMemory(OutDataA,16);
    ZeroMemory(OutDataB,16);
    ZeroMemory(InDataA,16);
    ZeroMemory(InDataB,16);
    TVTTAPI_Int_CodeCon(Pass,Con);
    return;
    };

CopyMemory(Buff,InDataA,16);

TVTTAPI_Int_CodeCon(Pass,Con);

InKey=0;
ZeroMemory(OutDataA,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

SetLastError(ERROR_SUCCESS);
return;
};

/*****************************************************************************
Funkcja odczytuje wartoc z licznika uniwersalnego
We:
    Adres na 16-bajtowy klucz do poczenia
    Uchwyt na poczenie
    Numer licznika do odczytania
Wy:
    Warto odczytana z licznika
    ustawiony "LastError"
*****************************************************************************/

DWORD TVTTAPI_CounterRead(BYTE Pass[16],void *hCon,BYTE CNr)
{
TVTTAPI_INT_CON   *Con=(TVTTAPI_INT_CON*) hCon;
DWORD   Res;

BYTE    OutDataA[16];
BYTE    OutDataB[16];
BYTE    InDataA[16];
BYTE    InDataB[16];
DWORD   InKey;

if((!Pass)||(!hCon))
    {
    SetLastError(ERROR_INVALID_DATA);
    return(0);
    };

TVTTAPI_Int_DecodeCon(Pass,Con);

ZeroMemory(OutDataA,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

Con->OutKey++;
OutDataB[TVTTD_CMD]=TVTTC_CNT_READ;
OutDataB[TVTTD_PARAM1]=CNr;

TVTT_Calc(OutDataA,OutDataB);
TVTT_CryptBlock(OutDataA,Con->OutKey,Con->Key,TVTT_BLOCK_A,TVTT_PC2T);
TVTT_CryptBlock(OutDataB,Con->OutKey,Con->Key,TVTT_BLOCK_B,TVTT_PC2T);
Res=TVTT_Talk(Con->hToken,5,Con->OutKey,OutDataA,OutDataB,&InKey,InDataA,InDataB);
TVTT_CryptBlock(InDataA,InKey,Con->Key,TVTT_BLOCK_A,TVTT_T2PC);
TVTT_CryptBlock(InDataB,InKey,Con->Key,TVTT_BLOCK_B,TVTT_T2PC);
if (TVTTAPI_Int_CheckError(Con,Res,InKey,InDataA,InDataB))
    {
    InKey=0;
    ZeroMemory(OutDataA,16);
    ZeroMemory(OutDataB,16);
    ZeroMemory(InDataA,16);
    ZeroMemory(InDataB,16);
    TVTTAPI_Int_CodeCon(Pass,Con);
    return(0);
    };

Res=InDataA[1];
Res=Res<<8;
Res|=InDataA[0];

TVTTAPI_Int_CodeCon(Pass,Con);

InKey=0;
ZeroMemory(OutDataA,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

SetLastError(ERROR_SUCCESS);
return(Res);
};

/*****************************************************************************
Funkcja zwiksza licznik i odczytuje jego warto
We:
    Adres na 16-bajtowy klucz do poczenia
    Uchwyt na poczenie
    Numer licznika do odczytania
Wy:
    Warto odczytana z licznika
    ustawiony "LastError"
*****************************************************************************/

DWORD TVTTAPI_CounterIncRead(BYTE Pass[16],void *hCon,BYTE CNr)
{
TVTTAPI_INT_CON   *Con=(TVTTAPI_INT_CON*) hCon;
DWORD   Res;

BYTE    OutDataA[16];
BYTE    OutDataB[16];
BYTE    InDataA[16];
BYTE    InDataB[16];
DWORD   InKey;

if((!Pass)||(!hCon))
    {
    SetLastError(ERROR_INVALID_DATA);
    return(0);
    };

TVTTAPI_Int_DecodeCon(Pass,Con);

ZeroMemory(OutDataA,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

Con->OutKey++;
OutDataB[TVTTD_CMD]=TVTTC_CNT_INC_READ;
OutDataB[TVTTD_PARAM1]=CNr;

TVTT_Calc(OutDataA,OutDataB);
TVTT_CryptBlock(OutDataA,Con->OutKey,Con->Key,TVTT_BLOCK_A,TVTT_PC2T);
TVTT_CryptBlock(OutDataB,Con->OutKey,Con->Key,TVTT_BLOCK_B,TVTT_PC2T);
Res=TVTT_Talk(Con->hToken,5,Con->OutKey,OutDataA,OutDataB,&InKey,InDataA,InDataB);
TVTT_CryptBlock(InDataA,InKey,Con->Key,TVTT_BLOCK_A,TVTT_T2PC);
TVTT_CryptBlock(InDataB,InKey,Con->Key,TVTT_BLOCK_B,TVTT_T2PC);
if (TVTTAPI_Int_CheckError(Con,Res,InKey,InDataA,InDataB))
    {
    InKey=0;
    ZeroMemory(OutDataA,16);
    ZeroMemory(OutDataB,16);
    ZeroMemory(InDataA,16);
    ZeroMemory(InDataB,16);
    TVTTAPI_Int_CodeCon(Pass,Con);
    return(0);
    };

Res=InDataA[1];
Res=Res<<8;
Res|=InDataA[0];

TVTTAPI_Int_CodeCon(Pass,Con);

InKey=0;
ZeroMemory(OutDataA,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

SetLastError(ERROR_SUCCESS);
return(Res);
};

/*****************************************************************************
Funkcja zmniejsza licznik i odczytuje jego warto
We:
    Adres na 16-bajtowy klucz do poczenia
    Uchwyt na poczenie
    Numer licznika do odczytania
Wy:
    Warto odczytana z licznika
    ustawiony "LastError"
*****************************************************************************/

DWORD TVTTAPI_CounterDecRead(BYTE Pass[16],void *hCon,BYTE CNr)
{
TVTTAPI_INT_CON   *Con=(TVTTAPI_INT_CON*) hCon;
DWORD   Res;

BYTE    OutDataA[16];
BYTE    OutDataB[16];
BYTE    InDataA[16];
BYTE    InDataB[16];
DWORD   InKey;

if((!Pass)||(!hCon))
    {
    SetLastError(ERROR_INVALID_DATA);
    return(0);
    };

TVTTAPI_Int_DecodeCon(Pass,Con);

ZeroMemory(OutDataA,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

Con->OutKey++;
OutDataB[TVTTD_CMD]=TVTTC_CNT_DEC_READ;
OutDataB[TVTTD_PARAM1]=CNr;

TVTT_Calc(OutDataA,OutDataB);
TVTT_CryptBlock(OutDataA,Con->OutKey,Con->Key,TVTT_BLOCK_A,TVTT_PC2T);
TVTT_CryptBlock(OutDataB,Con->OutKey,Con->Key,TVTT_BLOCK_B,TVTT_PC2T);
Res=TVTT_Talk(Con->hToken,5,Con->OutKey,OutDataA,OutDataB,&InKey,InDataA,InDataB);
TVTT_CryptBlock(InDataA,InKey,Con->Key,TVTT_BLOCK_A,TVTT_T2PC);
TVTT_CryptBlock(InDataB,InKey,Con->Key,TVTT_BLOCK_B,TVTT_T2PC);
if (TVTTAPI_Int_CheckError(Con,Res,InKey,InDataA,InDataB))
    {
    InKey=0;
    ZeroMemory(OutDataA,16);
    ZeroMemory(OutDataB,16);
    ZeroMemory(InDataA,16);
    ZeroMemory(InDataB,16);
    TVTTAPI_Int_CodeCon(Pass,Con);
    return(0);
    };

Res=InDataA[1];
Res=Res<<8;
Res|=InDataA[0];

TVTTAPI_Int_CodeCon(Pass,Con);

InKey=0;
ZeroMemory(OutDataA,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

SetLastError(ERROR_SUCCESS);
return(Res);
};

/*****************************************************************************
Funkcja zwiksza licznik, odczytuje jego zawartoc i odsa ja zaszyfrowan podanym hasem
We:
    Adres na 16-bajtowy klucz do poczenia
    Uchwyt na poczenie
    Numer licznika do odczytania
    Numer hasa ktrym ma nastpi szyfrowanie
    Adres na bufor na dane
Wy:
    wypeniony bufor na dane
    ustawiony "LastError"
*****************************************************************************/

void TVTTAPI_CounterIncEncryptRead(BYTE Pass[16],void *hCon,BYTE CNr,BYTE PNr,BYTE Buff[16])
{
TVTTAPI_INT_CON   *Con=(TVTTAPI_INT_CON*) hCon;
DWORD   Res;

BYTE    OutDataA[16];
BYTE    OutDataB[16];
BYTE    InDataA[16];
BYTE    InDataB[16];
DWORD   InKey;

if((!Pass)||(!hCon)||(!Buff))
    {
    SetLastError(ERROR_INVALID_DATA);
    return;
    };

ZeroMemory(Buff,16);

TVTTAPI_Int_DecodeCon(Pass,Con);

ZeroMemory(OutDataA,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

Con->OutKey++;
OutDataB[TVTTD_CMD]=TVTTC_CNT_INC_ENCRYPT_READ;
OutDataB[TVTTD_PARAM1]=CNr;
OutDataB[TVTTD_PARAM2]=PNr;

TVTT_Calc(OutDataA,OutDataB);
TVTT_CryptBlock(OutDataA,Con->OutKey,Con->Key,TVTT_BLOCK_A,TVTT_PC2T);
TVTT_CryptBlock(OutDataB,Con->OutKey,Con->Key,TVTT_BLOCK_B,TVTT_PC2T);
Res=TVTT_Talk(Con->hToken,5,Con->OutKey,OutDataA,OutDataB,&InKey,InDataA,InDataB);
TVTT_CryptBlock(InDataA,InKey,Con->Key,TVTT_BLOCK_A,TVTT_T2PC);
TVTT_CryptBlock(InDataB,InKey,Con->Key,TVTT_BLOCK_B,TVTT_T2PC);
if (TVTTAPI_Int_CheckError(Con,Res,InKey,InDataA,InDataB))
    {
    InKey=0;
    ZeroMemory(OutDataA,16);
    ZeroMemory(OutDataB,16);
    ZeroMemory(InDataA,16);
    ZeroMemory(InDataB,16);
    TVTTAPI_Int_CodeCon(Pass,Con);
    return;
    };

CopyMemory(Buff,InDataA,16);

TVTTAPI_Int_CodeCon(Pass,Con);

InKey=0;
ZeroMemory(OutDataA,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

SetLastError(ERROR_SUCCESS);
return;
};

/*****************************************************************************
Funkcja zapisuje warto do licznika uniwersalnego
We:
    Adres na 16-bajtowy klucz do poczenia
    Uchwyt na poczenie
    Numer licznika do zapisania
    Wartoc do zapisania
Wy:
    ustawiony "LastError"
*****************************************************************************/

void TVTTAPI_CounterWrite(BYTE Pass[16],void *hCon,BYTE CNr,DWORD Value)
{
TVTTAPI_INT_CON   *Con=(TVTTAPI_INT_CON*) hCon;
DWORD   Res;

BYTE    OutDataA[16];
BYTE    OutDataB[16];
BYTE    InDataA[16];
BYTE    InDataB[16];
DWORD   InKey;

if((!Pass)||(!hCon))
    {
    SetLastError(ERROR_INVALID_DATA);
    return;
    };

TVTTAPI_Int_DecodeCon(Pass,Con);

ZeroMemory(OutDataA,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

OutDataA[0]=(BYTE)Value;
Value=Value>>8;
OutDataA[1]=(BYTE)Value;
Value=0;

Con->OutKey++;
OutDataB[TVTTD_CMD]=TVTTC_CNT_WRITE;
OutDataB[TVTTD_PARAM1]=CNr;

TVTT_Calc(OutDataA,OutDataB);
TVTT_CryptBlock(OutDataA,Con->OutKey,Con->Key,TVTT_BLOCK_A,TVTT_PC2T);
TVTT_CryptBlock(OutDataB,Con->OutKey,Con->Key,TVTT_BLOCK_B,TVTT_PC2T);
Res=TVTT_Talk(Con->hToken,5,Con->OutKey,OutDataA,OutDataB,&InKey,InDataA,InDataB);
TVTT_CryptBlock(InDataA,InKey,Con->Key,TVTT_BLOCK_A,TVTT_T2PC);
TVTT_CryptBlock(InDataB,InKey,Con->Key,TVTT_BLOCK_B,TVTT_T2PC);
if (TVTTAPI_Int_CheckError(Con,Res,InKey,InDataA,InDataB))
    {
    InKey=0;
    ZeroMemory(OutDataA,16);
    ZeroMemory(OutDataB,16);
    ZeroMemory(InDataA,16);
    ZeroMemory(InDataB,16);
    TVTTAPI_Int_CodeCon(Pass,Con);
    return;
    };

TVTTAPI_Int_CodeCon(Pass,Con);

InKey=0;
ZeroMemory(OutDataA,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

SetLastError(ERROR_SUCCESS);
return;
};

/*****************************************************************************
Funkcja zapisuje dwa bajty konfiguracji licznika
We:
    Adres na 16-bajtowy klucz do poczenia
    Uchwyt na poczenie
    Numer licznika do zapisania konfiguracji
    Wartoc pierwszego bajtu konfiguracji
    Wartoc drugiego bajtu konfiguracji
Wy:
    ustawiony "LastError"
*****************************************************************************/

void TVTTAPI_CounterConfigWrite(BYTE Pass[16],void *hCon,BYTE CNr,BYTE Config0, BYTE Config1)
{
TVTTAPI_INT_CON   *Con=(TVTTAPI_INT_CON*) hCon;
DWORD   Res;

BYTE    OutDataA[16];
BYTE    OutDataB[16];
BYTE    InDataA[16];
BYTE    InDataB[16];
DWORD   InKey;

if((!Pass)||(!hCon))
    {
    SetLastError(ERROR_INVALID_DATA);
    return;
    };

TVTTAPI_Int_DecodeCon(Pass,Con);

ZeroMemory(OutDataA,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

OutDataA[0]=Config0;
OutDataA[1]=Config1;

Con->OutKey++;
OutDataB[TVTTD_CMD]=TVTTC_CNT_WRITE_CONFIG;
OutDataB[TVTTD_PARAM1]=CNr;

TVTT_Calc(OutDataA,OutDataB);
TVTT_CryptBlock(OutDataA,Con->OutKey,Con->Key,TVTT_BLOCK_A,TVTT_PC2T);
TVTT_CryptBlock(OutDataB,Con->OutKey,Con->Key,TVTT_BLOCK_B,TVTT_PC2T);
Res=TVTT_Talk(Con->hToken,5,Con->OutKey,OutDataA,OutDataB,&InKey,InDataA,InDataB);
TVTT_CryptBlock(InDataA,InKey,Con->Key,TVTT_BLOCK_A,TVTT_T2PC);
TVTT_CryptBlock(InDataB,InKey,Con->Key,TVTT_BLOCK_B,TVTT_T2PC);
if (TVTTAPI_Int_CheckError(Con,Res,InKey,InDataA,InDataB))
    {
    InKey=0;
    ZeroMemory(OutDataA,16);
    ZeroMemory(OutDataB,16);
    ZeroMemory(InDataA,16);
    ZeroMemory(InDataB,16);
    TVTTAPI_Int_CodeCon(Pass,Con);
    return;
    };

TVTTAPI_Int_CodeCon(Pass,Con);

InKey=0;
ZeroMemory(OutDataA,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

SetLastError(ERROR_SUCCESS);
return;
};

/*****************************************************************************
Funkcja ustawia bity w dwuch bajtach konfiguracji licznika
We:
    Adres na 16-bajtowy klucz do poczenia
    Uchwyt na poczenie
    Numer licznika do zapisania konfiguracji
    Maska bitowa pierwszego bajtu konfiguracji
    Maska bitowa pierwszego bajtu konfiguracji
Wy:
    ustawiony "LastError"
*****************************************************************************/

void TVTTAPI_CounterConfigSet(BYTE Pass[16],void *hCon,BYTE CNr,BYTE Config0, BYTE Config1)
{
TVTTAPI_INT_CON   *Con=(TVTTAPI_INT_CON*) hCon;
DWORD   Res;

BYTE    OutDataA[16];
BYTE    OutDataB[16];
BYTE    InDataA[16];
BYTE    InDataB[16];
DWORD   InKey;

if((!Pass)||(!hCon))
    {
    SetLastError(ERROR_INVALID_DATA);
    return;
    };

TVTTAPI_Int_DecodeCon(Pass,Con);

ZeroMemory(OutDataA,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

OutDataA[0]=Config0;
OutDataA[1]=Config1;

Con->OutKey++;
OutDataB[TVTTD_CMD]=TVTTC_CNT_SET_CONFIG;
OutDataB[TVTTD_PARAM1]=CNr;

TVTT_Calc(OutDataA,OutDataB);
TVTT_CryptBlock(OutDataA,Con->OutKey,Con->Key,TVTT_BLOCK_A,TVTT_PC2T);
TVTT_CryptBlock(OutDataB,Con->OutKey,Con->Key,TVTT_BLOCK_B,TVTT_PC2T);
Res=TVTT_Talk(Con->hToken,5,Con->OutKey,OutDataA,OutDataB,&InKey,InDataA,InDataB);
TVTT_CryptBlock(InDataA,InKey,Con->Key,TVTT_BLOCK_A,TVTT_T2PC);
TVTT_CryptBlock(InDataB,InKey,Con->Key,TVTT_BLOCK_B,TVTT_T2PC);
if (TVTTAPI_Int_CheckError(Con,Res,InKey,InDataA,InDataB))
    {
    InKey=0;
    ZeroMemory(OutDataA,16);
    ZeroMemory(OutDataB,16);
    ZeroMemory(InDataA,16);
    ZeroMemory(InDataB,16);
    TVTTAPI_Int_CodeCon(Pass,Con);
    return;
    };

TVTTAPI_Int_CodeCon(Pass,Con);

InKey=0;
ZeroMemory(OutDataA,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

SetLastError(ERROR_SUCCESS);
return;
};

/*****************************************************************************
Funkcja kasuje bity w dwuch bajtach konfiguracji licznika
We:
    Adres na 16-bajtowy klucz do poczenia
    Uchwyt na poczenie
    Numer licznika do zapisania konfiguracji
    Maska bitowa pierwszego bajtu konfiguracji
    Maska bitowa pierwszego bajtu konfiguracji
Wy:
    ustawiony "LastError"
*****************************************************************************/

void TVTTAPI_CounterConfigClear(BYTE Pass[16],void *hCon,BYTE CNr,BYTE Config0, BYTE Config1)
{
TVTTAPI_INT_CON   *Con=(TVTTAPI_INT_CON*) hCon;
DWORD   Res;

BYTE    OutDataA[16];
BYTE    OutDataB[16];
BYTE    InDataA[16];
BYTE    InDataB[16];
DWORD   InKey;

if((!Pass)||(!hCon))
    {
    SetLastError(ERROR_INVALID_DATA);
    return;
    };

TVTTAPI_Int_DecodeCon(Pass,Con);

ZeroMemory(OutDataA,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

OutDataA[0]=Config0;
OutDataA[1]=Config1;

Con->OutKey++;
OutDataB[TVTTD_CMD]=TVTTC_CNT_CLR_CONFIG;
OutDataB[TVTTD_PARAM1]=CNr;

TVTT_Calc(OutDataA,OutDataB);
TVTT_CryptBlock(OutDataA,Con->OutKey,Con->Key,TVTT_BLOCK_A,TVTT_PC2T);
TVTT_CryptBlock(OutDataB,Con->OutKey,Con->Key,TVTT_BLOCK_B,TVTT_PC2T);
Res=TVTT_Talk(Con->hToken,5,Con->OutKey,OutDataA,OutDataB,&InKey,InDataA,InDataB);
TVTT_CryptBlock(InDataA,InKey,Con->Key,TVTT_BLOCK_A,TVTT_T2PC);
TVTT_CryptBlock(InDataB,InKey,Con->Key,TVTT_BLOCK_B,TVTT_T2PC);
if (TVTTAPI_Int_CheckError(Con,Res,InKey,InDataA,InDataB))
    {
    InKey=0;
    ZeroMemory(OutDataA,16);
    ZeroMemory(OutDataB,16);
    ZeroMemory(InDataA,16);
    ZeroMemory(InDataB,16);
    TVTTAPI_Int_CodeCon(Pass,Con);
    return;
    };

TVTTAPI_Int_CodeCon(Pass,Con);

InKey=0;
ZeroMemory(OutDataA,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

SetLastError(ERROR_SUCCESS);
return;
};

/*****************************************************************************
Funkcja zapisuje haso do tablicy hase
We:
    Adres na 16-bajtowy klucz do poczenia
    Uchwyt na poczenie
    Numer pozycji w tablicy hase
    Adres na bufor z hasem do zapisania
Wy:
    ustawiony "LastError"
*****************************************************************************/

void TVTTAPI_PassWrite(BYTE Pass[16],void *hCon,BYTE PNr,BYTE Buff[16])
{
TVTTAPI_INT_CON   *Con=(TVTTAPI_INT_CON*) hCon;
DWORD   Res;

BYTE    OutDataA[16];
BYTE    OutDataB[16];
BYTE    InDataA[16];
BYTE    InDataB[16];
DWORD   InKey;

if((!Pass)||(!hCon)||(!Buff))
    {
    SetLastError(ERROR_INVALID_DATA);
    return;
    };

TVTTAPI_Int_DecodeCon(Pass,Con);

CopyMemory(OutDataA,Buff,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

Con->OutKey++;
OutDataB[TVTTD_CMD]=TVTTC_PASS_WRITE;
OutDataB[TVTTD_PARAM1]=PNr;

TVTT_Calc(OutDataA,OutDataB);
TVTT_CryptBlock(OutDataA,Con->OutKey,Con->Key,TVTT_BLOCK_A,TVTT_PC2T);
TVTT_CryptBlock(OutDataB,Con->OutKey,Con->Key,TVTT_BLOCK_B,TVTT_PC2T);
Res=TVTT_Talk(Con->hToken,5,Con->OutKey,OutDataA,OutDataB,&InKey,InDataA,InDataB);
TVTT_CryptBlock(InDataA,InKey,Con->Key,TVTT_BLOCK_A,TVTT_T2PC);
TVTT_CryptBlock(InDataB,InKey,Con->Key,TVTT_BLOCK_B,TVTT_T2PC);
if (TVTTAPI_Int_CheckError(Con,Res,InKey,InDataA,InDataB))
    {
    InKey=0;
    ZeroMemory(OutDataA,16);
    ZeroMemory(OutDataB,16);
    ZeroMemory(InDataA,16);
    ZeroMemory(InDataB,16);
    TVTTAPI_Int_CodeCon(Pass,Con);
    return;
    };

TVTTAPI_Int_CodeCon(Pass,Con);

InKey=0;
ZeroMemory(OutDataA,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

SetLastError(ERROR_SUCCESS);
return;
};

/*****************************************************************************
Funkcja zapisuje dwa bajty konfiguracji hasa
We:
    Adres na 16-bajtowy klucz do poczenia
    Uchwyt na poczenie
    Numer hasa do zapisania konfiguracji
    Wartoc pierwszego bajtu konfiguracji
    Wartoc drugiego bajtu konfiguracji
Wy:
    ustawiony "LastError"
*****************************************************************************/

void TVTTAPI_PassConfigWrite(BYTE Pass[16],void *hCon,BYTE PNr,BYTE Config0, BYTE Config1)
{
TVTTAPI_INT_CON   *Con=(TVTTAPI_INT_CON*) hCon;
DWORD   Res;

BYTE    OutDataA[16];
BYTE    OutDataB[16];
BYTE    InDataA[16];
BYTE    InDataB[16];
DWORD   InKey;

if((!Pass)||(!hCon))
    {
    SetLastError(ERROR_INVALID_DATA);
    return;
    };

TVTTAPI_Int_DecodeCon(Pass,Con);

ZeroMemory(OutDataA,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

OutDataA[0]=Config0;
OutDataA[1]=Config1;

Con->OutKey++;
OutDataB[TVTTD_CMD]=TVTTC_PASS_WRITE_CONFIG;
OutDataB[TVTTD_PARAM1]=PNr;

TVTT_Calc(OutDataA,OutDataB);
TVTT_CryptBlock(OutDataA,Con->OutKey,Con->Key,TVTT_BLOCK_A,TVTT_PC2T);
TVTT_CryptBlock(OutDataB,Con->OutKey,Con->Key,TVTT_BLOCK_B,TVTT_PC2T);
Res=TVTT_Talk(Con->hToken,5,Con->OutKey,OutDataA,OutDataB,&InKey,InDataA,InDataB);
TVTT_CryptBlock(InDataA,InKey,Con->Key,TVTT_BLOCK_A,TVTT_T2PC);
TVTT_CryptBlock(InDataB,InKey,Con->Key,TVTT_BLOCK_B,TVTT_T2PC);
if (TVTTAPI_Int_CheckError(Con,Res,InKey,InDataA,InDataB))
    {
    InKey=0;
    ZeroMemory(OutDataA,16);
    ZeroMemory(OutDataB,16);
    ZeroMemory(InDataA,16);
    ZeroMemory(InDataB,16);
    TVTTAPI_Int_CodeCon(Pass,Con);
    return;
    };

TVTTAPI_Int_CodeCon(Pass,Con);

InKey=0;
ZeroMemory(OutDataA,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

SetLastError(ERROR_SUCCESS);
return;
};

/*****************************************************************************
Funkcja ustawia bity w dwuch bajtach konfiguracji hasa
We:
    Adres na 16-bajtowy klucz do poczenia
    Uchwyt na poczenie
    Numer hasa do zapisania konfiguracji
    Maska bitowa pierwszego bajtu konfiguracji
    Maska bitowa pierwszego bajtu konfiguracji
Wy:
    ustawiony "LastError"
*****************************************************************************/

void TVTTAPI_PassConfigSet(BYTE Pass[16],void *hCon,BYTE PNr,BYTE Config0, BYTE Config1)
{
TVTTAPI_INT_CON   *Con=(TVTTAPI_INT_CON*) hCon;
DWORD   Res;

BYTE    OutDataA[16];
BYTE    OutDataB[16];
BYTE    InDataA[16];
BYTE    InDataB[16];
DWORD   InKey;

if((!Pass)||(!hCon))
    {
    SetLastError(ERROR_INVALID_DATA);
    return;
    };

TVTTAPI_Int_DecodeCon(Pass,Con);

ZeroMemory(OutDataA,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

OutDataA[0]=Config0;
OutDataA[1]=Config1;

Con->OutKey++;
OutDataB[TVTTD_CMD]=TVTTC_PASS_SET_CONFIG;
OutDataB[TVTTD_PARAM1]=PNr;

TVTT_Calc(OutDataA,OutDataB);
TVTT_CryptBlock(OutDataA,Con->OutKey,Con->Key,TVTT_BLOCK_A,TVTT_PC2T);
TVTT_CryptBlock(OutDataB,Con->OutKey,Con->Key,TVTT_BLOCK_B,TVTT_PC2T);
Res=TVTT_Talk(Con->hToken,5,Con->OutKey,OutDataA,OutDataB,&InKey,InDataA,InDataB);
TVTT_CryptBlock(InDataA,InKey,Con->Key,TVTT_BLOCK_A,TVTT_T2PC);
TVTT_CryptBlock(InDataB,InKey,Con->Key,TVTT_BLOCK_B,TVTT_T2PC);
if (TVTTAPI_Int_CheckError(Con,Res,InKey,InDataA,InDataB))
    {
    InKey=0;
    ZeroMemory(OutDataA,16);
    ZeroMemory(OutDataB,16);
    ZeroMemory(InDataA,16);
    ZeroMemory(InDataB,16);
    TVTTAPI_Int_CodeCon(Pass,Con);
    return;
    };

TVTTAPI_Int_CodeCon(Pass,Con);

InKey=0;
ZeroMemory(OutDataA,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

SetLastError(ERROR_SUCCESS);
return;
};

/*****************************************************************************
Funkcja kasuje bity w dwuch bajtach konfiguracji hasa
We:
    Adres na 16-bajtowy klucz do poczenia
    Uchwyt na poczenie
    Numer hasa do zapisania konfiguracji
    Maska bitowa pierwszego bajtu konfiguracji
    Maska bitowa pierwszego bajtu konfiguracji
Wy:
    ustawiony "LastError"
*****************************************************************************/

void TVTTAPI_PassConfigClear(BYTE Pass[16],void *hCon,BYTE PNr,BYTE Config0, BYTE Config1)
{
TVTTAPI_INT_CON   *Con=(TVTTAPI_INT_CON*) hCon;
DWORD   Res;

BYTE    OutDataA[16];
BYTE    OutDataB[16];
BYTE    InDataA[16];
BYTE    InDataB[16];
DWORD   InKey;

if((!Pass)||(!hCon))
    {
    SetLastError(ERROR_INVALID_DATA);
    return;
    };

TVTTAPI_Int_DecodeCon(Pass,Con);

ZeroMemory(OutDataA,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

OutDataA[0]=Config0;
OutDataA[1]=Config1;

Con->OutKey++;
OutDataB[TVTTD_CMD]=TVTTC_PASS_CLR_CONFIG;
OutDataB[TVTTD_PARAM1]=PNr;

TVTT_Calc(OutDataA,OutDataB);
TVTT_CryptBlock(OutDataA,Con->OutKey,Con->Key,TVTT_BLOCK_A,TVTT_PC2T);
TVTT_CryptBlock(OutDataB,Con->OutKey,Con->Key,TVTT_BLOCK_B,TVTT_PC2T);
Res=TVTT_Talk(Con->hToken,5,Con->OutKey,OutDataA,OutDataB,&InKey,InDataA,InDataB);
TVTT_CryptBlock(InDataA,InKey,Con->Key,TVTT_BLOCK_A,TVTT_T2PC);
TVTT_CryptBlock(InDataB,InKey,Con->Key,TVTT_BLOCK_B,TVTT_T2PC);
if (TVTTAPI_Int_CheckError(Con,Res,InKey,InDataA,InDataB))
    {
    InKey=0;
    ZeroMemory(OutDataA,16);
    ZeroMemory(OutDataB,16);
    ZeroMemory(InDataA,16);
    ZeroMemory(InDataB,16);
    TVTTAPI_Int_CodeCon(Pass,Con);
    return;
    };

TVTTAPI_Int_CodeCon(Pass,Con);

InKey=0;
ZeroMemory(OutDataA,16);
ZeroMemory(OutDataB,16);
ZeroMemory(InDataA,16);
ZeroMemory(InDataB,16);

SetLastError(ERROR_SUCCESS);
return;
};

/*****************************************************************************
Funkcja zwalnia pami zajt przez funkcje szyfrujc dane
    (funkcje szyfrujce bloki o dowolnym rozmiarze)
We:
    Adres na 16-bajtowy klucz do poczenia
    Uchwyt na poczenie
    Numer hasa do szyfrowania
    Adres na blok zwrcony przez funkcj szyfrujc
    Rozmiar bloku zwrcony przez funkcj szyfrujc
Wy:
    ustawiony "LastError"
*****************************************************************************/
void TVTTAPI_FreeBlock(BYTE *Buff,DWORD Size)
{
if((!Buff)||(Size<(3*16)))
    {
    SetLastError(ERROR_INVALID_DATA);
    return;
    }
ZeroMemory(Buff,Size);
GlobalFree(Buff);
};

/*****************************************************************************
Funkcja szyfruje blok danych o dowolnym rozmiarze
We:
    Adres na 16-bajtowy klucz do poczenia
    Uchwyt na poczenie
    Numer hasa do szyfrowania
    Adres na blok do zaszyfrowania
    Rozmiar bloku do zaszyfrowania
    Adres na zmienn do ktrej zostanie wpisany rozmiar bloku po zaszyfrowaniu
Wy:
    Adres na zaszyfrowany blok danych
    Rozmiar bloku zaszyfrowanego
    ustawiony "LastError"
*****************************************************************************/
BYTE * TVTTAPI_EncryptBlock(BYTE Pass[16], void*hCon, BYTE PNr, BYTE *Buff, DWORD Size, DWORD *OutSize)
{
DWORD    n,i;
DWORD    OSize;
BYTE    *OBuff;
BYTE     Key[16];

if((!Pass)||(!hCon)||(!Buff)||(!Size)||(!OutSize))
    {
    SetLastError(ERROR_INVALID_DATA);
    return(NULL);
    };

OSize=Size/16;
if (Size%16) OSize++;
OSize+=4;
OSize*=16;

OBuff=GlobalAlloc(GPTR,OSize);
if (!OBuff) return(NULL);

TVTT_Rand(OBuff+(0*16));
TVTT_Rand(OBuff+(2*16));
TVTT_Rand(OBuff+(3*16));

(OBuff+(1*16))[0]=(BYTE)(Size>>0);
(OBuff+(1*16))[1]=(BYTE)(Size>>8);
(OBuff+(1*16))[2]=(BYTE)(Size>>16);
(OBuff+(1*16))[3]=(BYTE)(Size>>24);

(OBuff+(1*16))[4]=(BYTE)(OSize>>0);
(OBuff+(1*16))[5]=(BYTE)(OSize>>8);
(OBuff+(1*16))[6]=(BYTE)(OSize>>16);
(OBuff+(1*16))[7]=(BYTE)(OSize>>24);

CopyMemory(OBuff+(4*16),Buff,Size);

CopyMemory(Key,OBuff+(0*16),16);
TVTTAPI_Encrypt(Pass,hCon,PNr,Key);
if (GetLastError()!=ERROR_SUCCESS)
    {
    ZeroMemory(OBuff,OSize);
    GlobalFree(OBuff);
    OBuff=NULL;
    OSize=0;
    return(NULL);
    };

rijndaelEncrypt(Key,OBuff+(1*16));

CopyMemory(Key,OBuff+(2*16),16);
TVTTAPI_Encrypt(Pass,hCon,PNr,Key);
if (GetLastError()!=ERROR_SUCCESS)
    {
    ZeroMemory(OBuff,OSize);
    GlobalFree(OBuff);
    OBuff=NULL;
    OSize=0;
    return(NULL);
    };

n=4*16;
while (n<OSize)
    {
    i=0;
    while (i<16)
        {
        OBuff[n+i]^=OBuff[n+i-16];
        i++;
        };
    rijndaelEncrypt(Key,OBuff+n);
    n+=16;
    };

SetLastError(ERROR_SUCCESS);
*OutSize=OSize;
return(OBuff);
};

/*****************************************************************************
Funkcja rozszyfruje wczeniej zasszyfrowany blok danych o dowolnym rozmiarze
We:
    Adres na 16-bajtowy klucz do poczenia
    Uchwyt na poczenie
    Numer hasa do szyfrowania
    Adres na blok do rozszyfrowania
    Adres na zmienn do ktrej zostanie wpisany rozmiar bloku po rozszyfrowaniu
Wy:
    Adres na rozszyfrowany blok danych
    Rozmiar bloku rozszyfrowanego
    ustawiony "LastError"
*****************************************************************************/

BYTE * TVTTAPI_DecryptBlock(BYTE Pass[16], void*hCon, BYTE PNr, BYTE *Buff, DWORD *OutSize)
{
DWORD    n,i;
DWORD    Size;
DWORD    TSize;
BYTE    *OBuff;
BYTE    *TBuff;
BYTE     Key[16];
BYTE     Tmp[16];

if((!Pass)||(!hCon)||(!Buff)||(!OutSize))
    {
    SetLastError(ERROR_INVALID_DATA);
    return(NULL);
    };

CopyMemory(Key,Buff+(0*16),16);
TVTTAPI_Encrypt(Pass,hCon,PNr,Key);
if (GetLastError()!=ERROR_SUCCESS)
    {
    ZeroMemory(Key,16);
    ZeroMemory(Tmp,16);
    OBuff=NULL;
    TSize=0;
    return(NULL);
    };

CopyMemory(Tmp,Buff+(1*16),16);
rijndaelDecrypt(Key,Tmp);

TSize=Tmp[7];
TSize=TSize<<8;
TSize|=Tmp[6];
TSize=TSize<<8;
TSize|=Tmp[5];
TSize=TSize<<8;
TSize|=Tmp[4];

Size=Tmp[3];
Size=Size<<8;
Size|=Tmp[2];
Size=Size<<8;
Size|=Tmp[1];
Size=Size<<8;
Size|=Tmp[0];

TBuff=GlobalAlloc(GPTR,TSize-(3*16));
if (!TBuff)
    {
    ZeroMemory(Key,16);
    ZeroMemory(Tmp,16);
    return(NULL);
    }

OBuff=GlobalAlloc(GPTR,Size);
if (!OBuff)
    {
    DWORD t=GetLastError();
    ZeroMemory(Key,16);
    ZeroMemory(Tmp,16);
    GlobalFree(TBuff);
    SetLastError(t);
    return(NULL);
    };

CopyMemory(TBuff,Buff+(3*16),TSize-(3*16));

CopyMemory(Key,Buff+(2*16),16);
TVTTAPI_Encrypt(Pass,hCon,PNr,Key);
if (GetLastError()!=ERROR_SUCCESS)
    {
    ZeroMemory(OBuff,Size);
    GlobalFree(OBuff);
    ZeroMemory(TBuff,TSize-(3*16));
    GlobalFree(TBuff);
    ZeroMemory(Key,16);
    ZeroMemory(Tmp,16);
    OBuff=NULL;
    TSize=0;
    return(NULL);
    };

n=TSize-(3*16)-16;
while (n>15)
    {
    rijndaelDecrypt(Key,TBuff+n);

    i=0;
    while (i<16)
        {
        TBuff[n+i]^=TBuff[n+i-16];
        i++;
        };

    n-=16;
    };

CopyMemory(OBuff,TBuff+16,Size);
ZeroMemory(TBuff,TSize-(3*16));
TBuff=0;
GlobalFree(TBuff);

SetLastError(ERROR_SUCCESS);
*OutSize=Size;
return(OBuff);
};
